/*
 * $Id: AP203Entities.java,v 1.1 2012/01/02 16:28:23 raira Exp $
 *
 * JSDAI(TM), a way to implement STEP, ISO 10303
 * Copyright (C) 1997-2009, LKSoftWare GmbH, Germany
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation (AGPL v3).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * JSDAI is a registered trademark of LKSoftWare GmbH, Germany
 * This software is also available under commercial licenses.
 * See also http://www.jsdai.net/
 */

package jsdaix.processor.xim_aim.util;

import java.util.TreeSet;

public class AP203Entities extends APInstancesProcessor {

		private AP203Entities() { }
		
		private static AP203Entities INSTANCE;
		
		public static AP203Entities getInstance(){
				if(INSTANCE == null){
						INSTANCE = new AP203Entities();
						createDictionary();
				}
				return INSTANCE;
		}
		
		private static void createDictionary(){
			types = new TreeSet();
			types.add("absorbed_dose_measure_with_unit");
			types.add("absorbed_dose_unit");
			types.add("abstract_variable");
			types.add("acceleration_measure_with_unit");
			types.add("acceleration_unit");
			types.add("action");
			types.add("action_assignment");
			types.add("action_directive");
			types.add("action_method");
			types.add("action_method_assignment");
			types.add("action_method_relationship");
			types.add("action_method_role");
			types.add("action_property");
			types.add("action_property_representation");
			types.add("action_relationship");
			types.add("action_request_assignment");
			types.add("action_request_solution");
			types.add("action_request_status");
			types.add("action_status");
			types.add("address");
			types.add("advanced_brep_shape_representation");
			types.add("advanced_face");
			types.add("alternate_product_relationship");
			types.add("amount_of_substance_measure_with_unit");
			types.add("amount_of_substance_unit");
			types.add("angle_direction_reference");
			types.add("angular_dimension");
			types.add("angular_location");
			types.add("angular_size");
			types.add("angularity_tolerance");
			types.add("annotation_curve_occurrence");
			types.add("annotation_fill_area");
			types.add("annotation_fill_area_occurrence");
			types.add("annotation_occurrence");
			types.add("annotation_occurrence_associativity");
			types.add("annotation_occurrence_relationship");
			types.add("annotation_plane");
			types.add("annotation_subfigure_occurrence");
			types.add("annotation_symbol");
			types.add("annotation_symbol_occurrence");
			types.add("annotation_text");
			types.add("annotation_text_character");
			types.add("annotation_text_occurrence");
			types.add("apex");
			types.add("application_context");
			types.add("application_context_element");
			types.add("application_protocol_definition");
			types.add("applied_action_assignment");
			types.add("applied_action_method_assignment");
			types.add("applied_action_request_assignment");
			types.add("applied_approval_assignment");
			types.add("applied_attribute_classification_assignment");
			types.add("applied_certification_assignment");
			types.add("applied_classification_assignment");
			types.add("applied_contract_assignment");
			types.add("applied_date_and_time_assignment");
			types.add("applied_date_assignment");
			types.add("applied_document_reference");
			types.add("applied_document_usage_constraint_assignment");
			types.add("applied_effectivity_assignment");
			types.add("applied_event_occurrence_assignment");
			types.add("applied_external_identification_assignment");
			types.add("applied_group_assignment");
			types.add("applied_identification_assignment");
			types.add("applied_name_assignment");
			types.add("applied_organization_assignment");
			types.add("applied_organizational_project_assignment");
			types.add("applied_person_and_organization_assignment");
			types.add("applied_presented_item");
			types.add("applied_security_classification_assignment");
			types.add("applied_time_interval_assignment");
			types.add("applied_usage_right");
			types.add("approval");
			types.add("approval_assignment");
			types.add("approval_date_time");
			types.add("approval_person_organization");
			types.add("approval_relationship");
			types.add("approval_role");
			types.add("approval_status");
			types.add("area_in_set");
			types.add("area_measure_with_unit");
			types.add("area_unit");
			types.add("assembly_component_usage");
			types.add("assembly_component_usage_substitute");
			types.add("assigned_requirement");
			types.add("atomic_formula");
			types.add("attribute_assertion");
			types.add("attribute_classification_assignment");
			types.add("attribute_language_assignment");
			types.add("attribute_value_assignment");
			types.add("attribute_value_role");
			types.add("auxiliary_geometric_representation_item");
			types.add("axis1_placement");
			types.add("axis2_placement_2d");
			types.add("axis2_placement_3d");
			types.add("b_spline_curve");
			types.add("b_spline_curve_with_knots");
			types.add("b_spline_surface");
			types.add("b_spline_surface_with_knots");
			types.add("back_chaining_rule");
			types.add("back_chaining_rule_body");
			types.add("background_colour");
			types.add("beveled_sheet_representation");
			types.add("bezier_curve");
			types.add("bezier_surface");
			types.add("binary_generic_expression");
			types.add("binary_numeric_expression");
			types.add("binary_representation_item");
			types.add("block");
			types.add("boolean_expression");
			types.add("boolean_literal");
			types.add("boolean_representation_item");
			types.add("boolean_result");
			types.add("boundary_curve");
			types.add("bounded_curve");
			types.add("bounded_pcurve");
			types.add("bounded_surface");
			types.add("bounded_surface_curve");
			types.add("box_domain");
			types.add("boxed_half_space");
			types.add("breakdown_context");
			types.add("breakdown_element_group_assignment");
			types.add("breakdown_element_realization");
			types.add("breakdown_element_usage");
			types.add("breakdown_of");
			types.add("brep_with_voids");
			types.add("bytes_representation_item");
			types.add("calendar_date");
			types.add("camera_image");
			types.add("camera_image_3d_with_scale");
			types.add("camera_model");
			types.add("camera_model_d3");
			types.add("camera_model_d3_multi_clipping");
			types.add("camera_model_d3_multi_clipping_intersection");
			types.add("camera_model_d3_multi_clipping_union");
			types.add("camera_model_d3_with_hlhsr");
			types.add("camera_model_with_light_sources");
			types.add("camera_usage");
			types.add("capacitance_measure_with_unit");
			types.add("capacitance_unit");
			types.add("cartesian_point");
			types.add("cartesian_transformation_operator");
			types.add("cartesian_transformation_operator_2d");
			types.add("cartesian_transformation_operator_3d");
			types.add("cc_design_approval");
			types.add("cc_design_certification");
			types.add("cc_design_contract");
			types.add("cc_design_date_and_time_assignment");
			types.add("cc_design_person_and_organization_assignment");
			types.add("cc_design_security_classification");
			types.add("cc_design_specification_reference");
			types.add("celsius_temperature_measure_with_unit");
			types.add("centre_of_symmetry");
			types.add("certification");
			types.add("certification_assignment");
			types.add("certification_type");
			types.add("change");
			types.add("change_request");
			types.add("character_glyph_font_usage");
			types.add("character_glyph_style_outline");
			types.add("character_glyph_style_stroke");
			types.add("character_glyph_symbol");
			types.add("character_glyph_symbol_outline");
			types.add("character_glyph_symbol_stroke");
			types.add("characteristic_data_column_header");
			types.add("characteristic_data_column_header_link");
			types.add("characteristic_data_table_header");
			types.add("characteristic_data_table_header_decomposition");
			types.add("characteristic_type");
			types.add("characterized_class");
			types.add("characterized_object");
			types.add("circle");
			types.add("circular_runout_tolerance");
			types.add("class");
			types.add("class_by_extension");
			types.add("class_by_intension");
			types.add("class_system");
			types.add("class_usage_effectivity_context_assignment");
			types.add("classification_assignment");
			types.add("classification_role");
			types.add("closed_shell");
			types.add("coaxiality_tolerance");
			types.add("colour");
			types.add("colour_rgb");
			types.add("colour_specification");
			types.add("common_datum");
			types.add("comparison_expression");
			types.add("complex_clause");
			types.add("complex_conjunctive_clause");
			types.add("complex_disjunctive_clause");
			types.add("complex_shelled_solid");
			types.add("composite_assembly_definition");
			types.add("composite_assembly_sequence_definition");
			types.add("composite_assembly_table");
			types.add("composite_curve");
			types.add("composite_curve_on_surface");
			types.add("composite_curve_segment");
			types.add("composite_material_designation");
			types.add("composite_shape_aspect");
			types.add("composite_sheet_representation");
			types.add("composite_text");
			types.add("composite_text_with_associated_curves");
			types.add("composite_text_with_blanking_box");
			types.add("composite_text_with_delineation");
			types.add("composite_text_with_extent");
			types.add("compound_representation_item");
			types.add("compound_shape_representation");
			types.add("concentricity_tolerance");
			types.add("concept_feature_operator");
			types.add("concept_feature_relationship");
			types.add("concept_feature_relationship_with_condition");
			types.add("conditional_concept_feature");
			types.add("conductance_measure_with_unit");
			types.add("conductance_unit");
			types.add("configurable_item");
			types.add("configuration_design");
			types.add("configuration_effectivity");
			types.add("configuration_item");
			types.add("configuration_item_hierarchical_relationship");
			types.add("configuration_item_relationship");
			types.add("configuration_item_revision_sequence");
			types.add("configured_effectivity_assignment");
			types.add("configured_effectivity_context_assignment");
			types.add("conic");
			types.add("conical_stepped_hole_transition");
			types.add("conical_surface");
			types.add("connected_edge_set");
			types.add("connected_face_set");
			types.add("connected_face_sub_set");
			types.add("constructive_geometry_representation");
			types.add("constructive_geometry_representation_relationship");
			types.add("contact_ratio_representation");
			types.add("context_dependent_invisibility");
			types.add("context_dependent_over_riding_styled_item");
			types.add("context_dependent_shape_representation");
			types.add("context_dependent_unit");
			types.add("contract");
			types.add("contract_assignment");
			types.add("contract_relationship");
			types.add("contract_type");
			types.add("conversion_based_unit");
			types.add("coordinated_universal_time_offset");
			types.add("csg_shape_representation");
			types.add("csg_solid");
			types.add("currency");
			types.add("currency_measure_with_unit");
			types.add("curve");
			types.add("curve_bounded_surface");
			types.add("curve_dimension");
			types.add("curve_replica");
			types.add("curve_style");
			types.add("curve_style_font");
			types.add("curve_style_font_and_scaling");
			types.add("curve_style_font_pattern");
			types.add("curve_style_rendering");
			types.add("curve_swept_solid_shape_representation");
			types.add("cylindrical_surface");
			types.add("cylindricity_tolerance");
			types.add("data_environment");
			types.add("date");
			types.add("date_and_time");
			types.add("date_and_time_assignment");
			types.add("date_assignment");
			types.add("date_representation_item");
			types.add("date_role");
			types.add("date_time_representation_item");
			types.add("date_time_role");
			types.add("dated_effectivity");
			types.add("datum");
			types.add("datum_feature");
			types.add("datum_feature_callout");
			types.add("datum_reference");
			types.add("datum_target");
			types.add("datum_target_callout");
			types.add("default_tolerance_table");
			types.add("default_tolerance_table_cell");
			types.add("defined_symbol");
			types.add("definitional_representation");
			types.add("definitional_representation_relationship");
			types.add("definitional_representation_relationship_with_same_context");
			types.add("degenerate_pcurve");
			types.add("degenerate_toroidal_surface");
			types.add("derived_shape_aspect");
			types.add("derived_unit");
			types.add("derived_unit_element");
			types.add("description_attribute");
			types.add("descriptive_representation_item");
			types.add("design_context");
			types.add("design_make_from_relationship");
			types.add("diameter_dimension");
			types.add("dielectric_constant_measure_with_unit");
			types.add("dimension_callout");
			types.add("dimension_callout_component_relationship");
			types.add("dimension_callout_relationship");
			types.add("dimension_curve");
			types.add("dimension_curve_directed_callout");
			types.add("dimension_curve_terminator");
			types.add("dimension_curve_terminator_to_projection_curve_associativity");
			types.add("dimension_pair");
			types.add("dimension_related_tolerance_zone_element");
			types.add("dimension_text_associativity");
			types.add("dimensional_characteristic_representation");
			types.add("dimensional_exponents");
			types.add("dimensional_location");
			types.add("dimensional_location_with_path");
			types.add("dimensional_size");
			types.add("dimensional_size_with_path");
			types.add("directed_action");
			types.add("directed_dimensional_location");
			types.add("direction");
			types.add("document");
			types.add("document_file");
			types.add("document_identifier");
			types.add("document_identifier_assignment");
			types.add("document_product_association");
			types.add("document_product_equivalence");
			types.add("document_reference");
			types.add("document_relationship");
			types.add("document_representation_type");
			types.add("document_type");
			types.add("document_usage_constraint");
			types.add("document_usage_constraint_assignment");
			types.add("document_usage_role");
			types.add("dose_equivalent_measure_with_unit");
			types.add("dose_equivalent_unit");
			types.add("double_offset_shelled_solid");
			types.add("draped_defined_transformation");
			types.add("draughting_annotation_occurrence");
			types.add("draughting_callout");
			types.add("draughting_callout_relationship");
			types.add("draughting_elements");
			types.add("draughting_model");
			types.add("draughting_model_item_association");
			types.add("draughting_pre_defined_colour");
			types.add("draughting_pre_defined_curve_font");
			types.add("draughting_pre_defined_text_font");
			types.add("draughting_subfigure_representation");
			types.add("draughting_symbol_representation");
			types.add("draughting_text_literal_with_delineation");
			types.add("draughting_title");
			types.add("drawing_definition");
			types.add("drawing_revision");
			types.add("drawing_revision_sequence");
			types.add("drawing_sheet_revision");
			types.add("drawing_sheet_revision_sequence");
			types.add("drawing_sheet_revision_usage");
			types.add("edge");
			types.add("edge_based_wireframe_model");
			types.add("edge_based_wireframe_shape_representation");
			types.add("edge_blended_solid");
			types.add("edge_curve");
			types.add("edge_loop");
			types.add("effectivity");
			types.add("effectivity_assignment");
			types.add("effectivity_context_assignment");
			types.add("effectivity_context_role");
			types.add("effectivity_relationship");
			types.add("electric_charge_measure_with_unit");
			types.add("electric_charge_unit");
			types.add("electric_current_measure_with_unit");
			types.add("electric_current_unit");
			types.add("electric_potential_measure_with_unit");
			types.add("electric_potential_unit");
			types.add("elementary_brep_shape_representation");
			types.add("elementary_surface");
			types.add("ellipse");
			types.add("energy_measure_with_unit");
			types.add("energy_unit");
			types.add("entity_assertion");
			types.add("enum_reference_prefix");
			types.add("environment");
			types.add("evaluated_characteristic");
			types.add("evaluated_degenerate_pcurve");
			types.add("evaluation_product_definition");
			types.add("event_occurrence");
			types.add("event_occurrence_assignment");
			types.add("event_occurrence_relationship");
			types.add("event_occurrence_role");
			types.add("exclusive_product_concept_feature_category");
			types.add("executed_action");
			types.add("expanded_uncertainty");
			types.add("explicit_procedural_geometric_representation_item_relationship");
			types.add("explicit_procedural_representation_item_relationship");
			types.add("explicit_procedural_representation_relationship");
			types.add("explicit_procedural_shape_representation_relationship");
			types.add("expression");
			types.add("expression_conversion_based_unit");
			types.add("extension");
			types.add("extent");
			types.add("external_class_library");
			types.add("external_identification_assignment");
			types.add("external_source");
			types.add("external_source_relationship");
			types.add("externally_defined_class");
			types.add("externally_defined_colour");
			types.add("externally_defined_context_dependent_unit");
			types.add("externally_defined_conversion_based_unit");
			types.add("externally_defined_currency");
			types.add("externally_defined_curve_font");
			types.add("externally_defined_dimension_definition");
			types.add("externally_defined_general_property");
			types.add("externally_defined_hatch_style");
			types.add("externally_defined_item");
			types.add("externally_defined_item_relationship");
			types.add("externally_defined_marker");
			types.add("externally_defined_picture_representation_item");
			types.add("externally_defined_representation_item");
			types.add("externally_defined_string");
			types.add("externally_defined_symbol");
			types.add("externally_defined_terminator_symbol");
			types.add("externally_defined_text_font");
			types.add("externally_defined_tile");
			types.add("externally_defined_tile_style");
			types.add("extruded_area_solid");
			types.add("extruded_face_solid");
			types.add("extruded_face_solid_with_draft_angle");
			types.add("extruded_face_solid_with_multiple_draft_angles");
			types.add("extruded_face_solid_with_trim_conditions");
			types.add("face");
			types.add("face_based_surface_model");
			types.add("face_bound");
			types.add("face_outer_bound");
			types.add("face_surface");
			types.add("faceted_brep");
			types.add("faceted_brep_shape_representation");
			types.add("fact_type");
			types.add("fill_area_style");
			types.add("fill_area_style_colour");
			types.add("fill_area_style_hatching");
			types.add("fill_area_style_tile_coloured_region");
			types.add("fill_area_style_tile_curve_with_style");
			types.add("fill_area_style_tile_symbol_with_style");
			types.add("fill_area_style_tiles");
			types.add("flat_pattern_ply_representation_relationship");
			types.add("flatness_tolerance");
			types.add("force_measure_with_unit");
			types.add("force_unit");
			types.add("forward_chaining_rule");
			types.add("forward_chaining_rule_premise");
			types.add("founded_item");
			types.add("frequency_measure_with_unit");
			types.add("frequency_unit");
			types.add("func");
			types.add("functional_breakdown_context");
			types.add("functional_element_usage");
			types.add("functionally_defined_transformation");
			types.add("general_material_property");
			types.add("general_property");
			types.add("general_property_association");
			types.add("general_property_relationship");
			types.add("generic_character_glyph_symbol");
			types.add("generic_expression");
			types.add("generic_literal");
			types.add("generic_variable");
			types.add("geometric_alignment");
			types.add("geometric_curve_set");
			types.add("geometric_intersection");
			types.add("geometric_item_specific_usage");
			types.add("geometric_model_element_relationship");
			types.add("geometric_representation_context");
			types.add("geometric_representation_item");
			types.add("geometric_set");
			types.add("geometric_tolerance");
			types.add("geometric_tolerance_relationship");
			types.add("geometric_tolerance_with_datum_reference");
			types.add("geometric_tolerance_with_defined_unit");
			types.add("geometrical_tolerance_callout");
			types.add("geometrically_bounded_2d_wireframe_representation");
			types.add("geometrically_bounded_surface_shape_representation");
			types.add("geometrically_bounded_wireframe_shape_representation");
			types.add("global_assignment");
			types.add("global_uncertainty_assigned_context");
			types.add("global_unit_assigned_context");
			types.add("ground_fact");
			types.add("group");
			types.add("group_assignment");
			types.add("group_relationship");
			types.add("half_space_solid");
			types.add("hardness_representation");
			types.add("hidden_element_over_riding_styled_item");
			types.add("hyperbola");
			types.add("id_attribute");
			types.add("identification_assignment");
			types.add("identification_role");
			types.add("illuminance_measure_with_unit");
			types.add("illuminance_unit");
			types.add("included_text_block");
			types.add("inclusion_product_concept_feature");
			types.add("indirectly_selected_elements");
			types.add("indirectly_selected_shape_elements");
			types.add("inductance_measure_with_unit");
			types.add("inductance_unit");
			types.add("information_right");
			types.add("information_usage_right");
			types.add("instance_usage_context_assignment");
			types.add("instanced_feature");
			types.add("int_literal");
			types.add("integer_representation_item");
			types.add("intersection_curve");
			types.add("interval_expression");
			types.add("invisibility");
			types.add("iso4217_currency");
			types.add("item_defined_transformation");
			types.add("item_identified_representation_usage");
			types.add("known_source");
			types.add("laid_defined_transformation");
			types.add("laminate_table");
			types.add("language");
			types.add("leader_curve");
			types.add("leader_directed_callout");
			types.add("leader_directed_dimension");
			types.add("leader_terminator");
			types.add("length_measure_with_unit");
			types.add("length_unit");
			types.add("light_source");
			types.add("light_source_ambient");
			types.add("light_source_directional");
			types.add("light_source_positional");
			types.add("light_source_spot");
			types.add("limits_and_fits");
			types.add("line");
			types.add("line_profile_tolerance");
			types.add("linear_dimension");
			types.add("literal_conjunction");
			types.add("literal_disjunction");
			types.add("literal_number");
			types.add("local_time");
			types.add("logical_literal");
			types.add("logical_representation_item");
			types.add("loop");
			types.add("loss_tangent_measure_with_unit");
			types.add("lot_effectivity");
			types.add("luminous_flux_measure_with_unit");
			types.add("luminous_flux_unit");
			types.add("luminous_intensity_measure_with_unit");
			types.add("luminous_intensity_unit");
			types.add("magnetic_flux_density_measure_with_unit");
			types.add("magnetic_flux_density_unit");
			types.add("magnetic_flux_measure_with_unit");
			types.add("magnetic_flux_unit");
			types.add("make_from_usage_option");
			types.add("manifold_solid_brep");
			types.add("manifold_subsurface_shape_representation");
			types.add("manifold_surface_shape_representation");
			types.add("mapped_item");
			types.add("mass_measure_with_unit");
			types.add("mass_unit");
			types.add("material_designation");
			types.add("material_designation_characterization");
			types.add("material_property");
			types.add("material_property_representation");
			types.add("measure_qualification");
			types.add("measure_representation_item");
			types.add("measure_with_unit");
			types.add("mechanical_context");
			types.add("mechanical_design_and_draughting_relationship");
			types.add("mechanical_design_geometric_presentation_area");
			types.add("mechanical_design_geometric_presentation_representation");
			types.add("mechanical_design_presentation_representation_with_draughting");
			types.add("mechanical_design_shaded_presentation_area");
			types.add("mechanical_design_shaded_presentation_representation");
			types.add("min_and_major_ply_orientation_basis");
			types.add("modified_geometric_tolerance");
			types.add("modified_solid");
			types.add("modified_solid_with_placed_configuration");
			types.add("moments_of_inertia_representation");
			types.add("multi_language_attribute_assignment");
			types.add("multiple_arity_boolean_expression");
			types.add("multiple_arity_generic_expression");
			types.add("multiple_arity_numeric_expression");
			types.add("name_assignment");
			types.add("name_attribute");
			types.add("named_unit");
			types.add("next_assembly_usage_occurrence");
			types.add("non_manifold_surface_shape_representation");
			types.add("null_representation_item");
			types.add("numeric_expression");
			types.add("object_role");
			types.add("offset_curve_2d");
			types.add("offset_curve_3d");
			types.add("offset_surface");
			types.add("one_direction_repeat_factor");
			types.add("open_shell");
			types.add("ordinal_date");
			types.add("ordinate_dimension");
			types.add("organization");
			types.add("organization_assignment");
			types.add("organization_relationship");
			types.add("organization_role");
			types.add("organizational_address");
			types.add("organizational_project");
			types.add("organizational_project_assignment");
			types.add("organizational_project_relationship");
			types.add("organizational_project_role");
			types.add("oriented_closed_shell");
			types.add("oriented_edge");
			types.add("oriented_face");
			types.add("oriented_open_shell");
			types.add("oriented_path");
			types.add("oriented_surface");
			types.add("outer_boundary_curve");
			types.add("over_riding_styled_item");
			types.add("package_product_concept_feature");
			types.add("parabola");
			types.add("parallel_offset");
			types.add("parallelism_tolerance");
			types.add("parametric_representation_context");
			types.add("part_laminate_table");
			types.add("partial_document_with_structured_text_representation_assignment");
			types.add("path");
			types.add("pcurve");
			types.add("percentage_laminate_definition");
			types.add("percentage_laminate_table");
			types.add("percentage_ply_definition");
			types.add("perpendicular_to");
			types.add("perpendicularity_tolerance");
			types.add("person");
			types.add("person_and_organization");
			types.add("person_and_organization_address");
			types.add("person_and_organization_assignment");
			types.add("person_and_organization_role");
			types.add("personal_address");
			types.add("physical_breakdown_context");
			types.add("physical_element_usage");
			types.add("picture_representation");
			types.add("picture_representation_item");
			types.add("placed_datum_target_feature");
			types.add("placed_feature");
			types.add("placement");
			types.add("planar_box");
			types.add("planar_extent");
			types.add("plane");
			types.add("plane_angle_measure_with_unit");
			types.add("plane_angle_unit");
			types.add("plus_minus_tolerance");
			types.add("ply_laminate_definition");
			types.add("ply_laminate_sequence_definition");
			types.add("ply_laminate_table");
			types.add("point");
			types.add("point_and_vector");
			types.add("point_on_curve");
			types.add("point_on_surface");
			types.add("point_path");
			types.add("point_replica");
			types.add("point_style");
			types.add("polar_complex_number_literal");
			types.add("poly_loop");
			types.add("polyline");
			types.add("position_tolerance");
			types.add("positioned_sketch");
			types.add("power_measure_with_unit");
			types.add("power_unit");
			types.add("pre_defined_colour");
			types.add("pre_defined_curve_font");
			types.add("pre_defined_dimension_symbol");
			types.add("pre_defined_geometrical_tolerance_symbol");
			types.add("pre_defined_item");
			types.add("pre_defined_marker");
			types.add("pre_defined_point_marker_symbol");
			types.add("pre_defined_surface_condition_symbol");
			types.add("pre_defined_surface_side_style");
			types.add("pre_defined_symbol");
			types.add("pre_defined_terminator_symbol");
			types.add("pre_defined_text_font");
			types.add("pre_defined_tile");
			types.add("precision_qualifier");
			types.add("predefined_picture_representation_item");
			types.add("presentation_area");
			types.add("presentation_layer_assignment");
			types.add("presentation_representation");
			types.add("presentation_set");
			types.add("presentation_size");
			types.add("presentation_style_assignment");
			types.add("presentation_style_by_context");
			types.add("presentation_view");
			types.add("presented_item");
			types.add("presented_item_representation");
			types.add("pressure_measure_with_unit");
			types.add("pressure_unit");
			types.add("procedural_representation");
			types.add("procedural_representation_sequence");
			types.add("procedural_shape_representation");
			types.add("procedural_shape_representation_sequence");
			types.add("product");
			types.add("product_category");
			types.add("product_category_relationship");
			types.add("product_class");
			types.add("product_concept");
			types.add("product_concept_context");
			types.add("product_concept_feature");
			types.add("product_concept_feature_association");
			types.add("product_concept_feature_category");
			types.add("product_concept_feature_category_usage");
			types.add("product_concept_relationship");
			types.add("product_context");
			types.add("product_definition");
			types.add("product_definition_context");
			types.add("product_definition_context_association");
			types.add("product_definition_context_role");
			types.add("product_definition_effectivity");
			types.add("product_definition_element_relationship");
			types.add("product_definition_formation");
			types.add("product_definition_formation_relationship");
			types.add("product_definition_formation_with_specified_source");
			types.add("product_definition_group_assignment");
			types.add("product_definition_occurrence_relationship");
			types.add("product_definition_relationship");
			types.add("product_definition_shape");
			types.add("product_definition_substitute");
			types.add("product_definition_usage");
			types.add("product_definition_with_associated_documents");
			types.add("product_identification");
			types.add("product_material_composition_relationship");
			types.add("product_related_product_category");
			types.add("product_specification");
			types.add("projected_zone_definition");
			types.add("projection_curve");
			types.add("projection_directed_callout");
			types.add("promissory_usage_occurrence");
			types.add("property_definition");
			types.add("property_definition_relationship");
			types.add("property_definition_representation");
			types.add("qualified_representation_item");
			types.add("qualitative_uncertainty");
			types.add("quantified_assembly_component_usage");
			types.add("quasi_uniform_curve");
			types.add("quasi_uniform_surface");
			types.add("radioactivity_measure_with_unit");
			types.add("radioactivity_unit");
			types.add("radius_dimension");
			types.add("range_characteristic");
			types.add("ratio_measure_with_unit");
			types.add("ratio_unit");
			types.add("rational_b_spline_curve");
			types.add("rational_b_spline_surface");
			types.add("rational_representation_item");
			types.add("real_literal");
			types.add("real_representation_item");
			types.add("rectangular_composite_surface");
			types.add("rectangular_trimmed_surface");
			types.add("referenced_modified_datum");
			types.add("relative_event_occurrence");
			types.add("rep_item_group");
			types.add("reparametrised_composite_curve_segment");
			types.add("representation");
			types.add("representation_context");
			types.add("representation_item");
			types.add("representation_item_relationship");
			types.add("representation_map");
			types.add("representation_relationship");
			types.add("representation_relationship_with_transformation");
			types.add("requirement_assigned_object");
			types.add("requirement_assignment");
			types.add("requirement_source");
			types.add("requirement_view_definition_relationship");
			types.add("resistance_measure_with_unit");
			types.add("resistance_unit");
			types.add("revolved_area_solid");
			types.add("revolved_face_solid");
			types.add("revolved_face_solid_with_trim_conditions");
			types.add("right_angular_wedge");
			types.add("right_circular_cone");
			types.add("right_circular_cylinder");
			types.add("right_to_usage_association");
			types.add("role_association");
			types.add("roundness_tolerance");
			types.add("row_representation_item");
			types.add("row_value");
			types.add("row_variable");
			types.add("rule_action");
			types.add("rule_condition");
			types.add("rule_definition");
			types.add("rule_set");
			types.add("rule_set_group");
			types.add("rule_software_definition");
			types.add("rule_superseded_assignment");
			types.add("rule_supersedence");
			types.add("ruled_surface_swept_area_solid");
			types.add("runout_zone_definition");
			types.add("runout_zone_orientation");
			types.add("runout_zone_orientation_reference_direction");
			types.add("satisfied_requirement");
			types.add("satisfies_requirement");
			types.add("satisfying_item");
			types.add("scalar_variable");
			types.add("scattering_parameter");
			types.add("sculptured_solid");
			types.add("seam_curve");
			types.add("security_classification");
			types.add("security_classification_assignment");
			types.add("security_classification_level");
			types.add("serial_numbered_effectivity");
			types.add("shape_aspect");
			types.add("shape_aspect_associativity");
			types.add("shape_aspect_deriving_relationship");
			types.add("shape_aspect_relationship");
			types.add("shape_definition_representation");
			types.add("shape_dimension_representation");
			types.add("shape_feature_definition");
			types.add("shape_representation");
			types.add("shape_representation_relationship");
			types.add("shape_representation_with_parameters");
			types.add("shell_based_surface_model");
			types.add("shell_based_wireframe_model");
			types.add("shell_based_wireframe_shape_representation");
			types.add("shelled_solid");
			types.add("si_absorbed_dose_unit");
			types.add("si_capacitance_unit");
			types.add("si_conductance_unit");
			types.add("si_dose_equivalent_unit");
			types.add("si_electric_charge_unit");
			types.add("si_electric_potential_unit");
			types.add("si_energy_unit");
			types.add("si_force_unit");
			types.add("si_frequency_unit");
			types.add("si_illuminance_unit");
			types.add("si_inductance_unit");
			types.add("si_magnetic_flux_density_unit");
			types.add("si_magnetic_flux_unit");
			types.add("si_power_unit");
			types.add("si_pressure_unit");
			types.add("si_radioactivity_unit");
			types.add("si_resistance_unit");
			types.add("si_unit");
			types.add("simple_boolean_expression");
			types.add("simple_clause");
			types.add("simple_generic_expression");
			types.add("simple_numeric_expression");
			types.add("slash_expression");
			types.add("smeared_material_definition");
			types.add("solid_angle_measure_with_unit");
			types.add("solid_angle_unit");
			types.add("solid_curve_font");
			types.add("solid_model");
			types.add("solid_replica");
			types.add("solid_with_angle_based_chamfer");
			types.add("solid_with_chamfered_edges");
			types.add("solid_with_circular_pattern");
			types.add("solid_with_circular_pocket");
			types.add("solid_with_circular_protrusion");
			types.add("solid_with_conical_bottom_round_hole");
			types.add("solid_with_constant_radius_edge_blend");
			types.add("solid_with_curved_slot");
			types.add("solid_with_depression");
			types.add("solid_with_double_offset_chamfer");
			types.add("solid_with_flat_bottom_round_hole");
			types.add("solid_with_general_pocket");
			types.add("solid_with_general_protrusion");
			types.add("solid_with_groove");
			types.add("solid_with_hole");
			types.add("solid_with_incomplete_circular_pattern");
			types.add("solid_with_incomplete_rectangular_pattern");
			types.add("solid_with_pocket");
			types.add("solid_with_protrusion");
			types.add("solid_with_rectangular_pattern");
			types.add("solid_with_rectangular_pocket");
			types.add("solid_with_rectangular_protrusion");
			types.add("solid_with_shape_element_pattern");
			types.add("solid_with_single_offset_chamfer");
			types.add("solid_with_slot");
			types.add("solid_with_spherical_bottom_round_hole");
			types.add("solid_with_stepped_round_hole");
			types.add("solid_with_stepped_round_hole_and_conical_transitions");
			types.add("solid_with_straight_slot");
			types.add("solid_with_tee_section_slot");
			types.add("solid_with_through_depression");
			types.add("solid_with_trapezoidal_section_slot");
			types.add("solid_with_variable_radius_edge_blend");
			types.add("source_for_requirement");
			types.add("sourced_requirement");
			types.add("specification_definition");
			types.add("specified_higher_usage_occurrence");
			types.add("sphere");
			types.add("spherical_surface");
			types.add("standard_uncertainty");
			types.add("start_request");
			types.add("start_work");
			types.add("straightness_tolerance");
			types.add("structured_dimension_callout");
			types.add("structured_text_composition");
			types.add("structured_text_representation");
			types.add("styled_item");
			types.add("subedge");
			types.add("subface");
			types.add("supplied_part_relationship");
			types.add("surface");
			types.add("surface_condition_callout");
			types.add("surface_curve");
			types.add("surface_curve_swept_area_solid");
			types.add("surface_of_linear_extrusion");
			types.add("surface_of_revolution");
			types.add("surface_patch");
			types.add("surface_profile_tolerance");
			types.add("surface_rendering_properties");
			types.add("surface_replica");
			types.add("surface_side_style");
			types.add("surface_style_boundary");
			types.add("surface_style_control_grid");
			types.add("surface_style_fill_area");
			types.add("surface_style_parameter_line");
			types.add("surface_style_reflectance_ambient");
			types.add("surface_style_reflectance_ambient_diffuse");
			types.add("surface_style_reflectance_ambient_diffuse_specular");
			types.add("surface_style_rendering");
			types.add("surface_style_rendering_with_properties");
			types.add("surface_style_segmentation_curve");
			types.add("surface_style_silhouette");
			types.add("surface_style_transparent");
			types.add("surface_style_usage");
			types.add("surface_texture_representation");
			types.add("surfaced_open_shell");
			types.add("swept_area_solid");
			types.add("swept_disk_solid");
			types.add("swept_face_solid");
			types.add("swept_surface");
			types.add("symbol");
			types.add("symbol_colour");
			types.add("symbol_representation");
			types.add("symbol_representation_map");
			types.add("symbol_style");
			types.add("symbol_target");
			types.add("symmetric_shape_aspect");
			types.add("symmetry_tolerance");
			types.add("table_representation_item");
			types.add("tactile_appearance_representation");
			types.add("tagged_text_format");
			types.add("tagged_text_item");
			types.add("tangent");
			types.add("terminator_symbol");
			types.add("text_font");
			types.add("text_font_family");
			types.add("text_font_in_family");
			types.add("text_literal");
			types.add("text_literal_with_associated_curves");
			types.add("text_literal_with_blanking_box");
			types.add("text_literal_with_delineation");
			types.add("text_literal_with_extent");
			types.add("text_string_representation");
			types.add("text_style");
			types.add("text_style_for_defined_font");
			types.add("text_style_with_box_characteristics");
			types.add("text_style_with_mirror");
			types.add("text_style_with_spacing");
			types.add("thermal_resistance_measure_with_unit");
			types.add("thermal_resistance_unit");
			types.add("thermodynamic_temperature_measure_with_unit");
			types.add("thermodynamic_temperature_unit");
			types.add("thickened_face_solid");
			types.add("thickness_laminate_definition");
			types.add("thickness_laminate_table");
			types.add("time_interval");
			types.add("time_interval_assignment");
			types.add("time_interval_based_effectivity");
			types.add("time_interval_relationship");
			types.add("time_interval_role");
			types.add("time_interval_with_bounds");
			types.add("time_measure_with_unit");
			types.add("time_unit");
			types.add("tolerance_value");
			types.add("tolerance_zone");
			types.add("tolerance_zone_definition");
			types.add("tolerance_zone_form");
			types.add("topological_representation_item");
			types.add("toroidal_surface");
			types.add("torus");
			types.add("total_runout_tolerance");
			types.add("track_blended_solid");
			types.add("track_blended_solid_with_end_conditions");
			types.add("transformation_with_derived_angle");
			types.add("trimmed_curve");
			types.add("two_direction_repeat_factor");
			types.add("type_qualifier");
			types.add("unary_generic_expression");
			types.add("unary_numeric_expression");
			types.add("uncertainty_assigned_representation");
			types.add("uncertainty_measure_with_unit");
			types.add("uncertainty_qualifier");
			types.add("uniform_curve");
			types.add("uniform_resource_identifier");
			types.add("uniform_surface");
			types.add("usage_association");
			types.add("user_defined_curve_font");
			types.add("user_defined_marker");
			types.add("user_defined_terminator_symbol");
			types.add("user_selected_elements");
			types.add("user_selected_shape_elements");
			types.add("value_range");
			types.add("value_representation_item");
			types.add("variable_semantics");
			types.add("variational_representation_item");
			types.add("vector");
			types.add("vector_style");
			types.add("velocity_measure_with_unit");
			types.add("velocity_unit");
			types.add("versioned_action_request");
			types.add("vertex");
			types.add("vertex_loop");
			types.add("vertex_point");
			types.add("vertex_shell");
			types.add("view_volume");
			types.add("visual_appearance_representation");
			types.add("volume_measure_with_unit");
			types.add("volume_unit");
			types.add("week_of_year_and_day_date");
			types.add("wire_shell");
			types.add("year_month");
			types.add("zone_structural_makeup");
		}
}
