/*
 * $Id: AP214Entities.java,v 1.1 2012/01/02 16:28:23 raira Exp $
 *
 * JSDAI(TM), a way to implement STEP, ISO 10303
 * Copyright (C) 1997-2009, LKSoftWare GmbH, Germany
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation (AGPL v3).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * JSDAI is a registered trademark of LKSoftWare GmbH, Germany
 * This software is also available under commercial licenses.
 * See also http://www.jsdai.net/
 */

package jsdaix.processor.xim_aim.util;

import java.util.TreeSet;

public class AP214Entities extends APInstancesProcessor {

		private AP214Entities() { }
		
		private static AP214Entities INSTANCE;
		
		public static AP214Entities getInstance(){
				if(INSTANCE == null){
						INSTANCE = new AP214Entities();
						createDictionary();
				}
				return INSTANCE;
		}
		
		private static void createDictionary(){
			types = new TreeSet();
			types.add("action");
			types.add("abs_function");
			types.add("acos_function");
			types.add("action.definition");
			types.add("action_assignment");
			types.add("action_directive");
			types.add("action_method");
			types.add("action_method_relationship");
			types.add("action_property");
			types.add("action_property_representation");
			types.add("action_relationship");
			types.add("action_request_assignment");
			types.add("action_request_solution");
			types.add("action_request_status");
			types.add("action_resource");
			types.add("action_resource_requirement");
			types.add("action_resource_type");
			types.add("action_status");
			types.add("address");
			types.add("advanced_brep_shape_representation");
			types.add("advanced_face");
			types.add("alternate_product_relationship");
			types.add("amount_of_substance_measure_with_unit");
			types.add("amount_of_substance_unit");
			types.add("and_expression");
			types.add("angularity_tolerance");
			types.add("angular_dimension");
			types.add("angular_location");
			types.add("angular_size");
			types.add("annotation_curve_occurrence");
			types.add("annotation_fill_area");
			types.add("annotation_fill_area_occurrence");
			types.add("annotation_occurrence");
			types.add("annotation_occurrence_associativity");
			types.add("annotation_occurrence_relationship");
			types.add("annotation_plane");
			types.add("annotation_subfigure_occurrence");
			types.add("annotation_symbol");
			types.add("annotation_symbol_occurrence");
			types.add("annotation_text");
			types.add("annotation_text_character");
			types.add("annotation_text_occurrence");
			types.add("apex");
			types.add("application_context");
			types.add("application_context_element");
			types.add("application_context_relationship");
			types.add("application_protocol_definition");
			types.add("applied_action_assignment");
			types.add("applied_action_request_assignment");
			types.add("applied_approval_assignment");
			types.add("applied_area");
			types.add("applied_certification_assignment");
			types.add("applied_classification_assignment");
			types.add("applied_contract_assignment");
			types.add("applied_date_and_time_assignment");
			types.add("applied_date_assignment");
			types.add("applied_document_reference");
			types.add("applied_document_usage_constraint_assignment");
			types.add("applied_effectivity_assignment");
			types.add("applied_event_occurrence_assignment");
			types.add("applied_external_identification_assignment");
			types.add("applied_group_assignment");
			types.add("applied_identification_assignment");
			types.add("applied_ineffectivity_assignment");
			types.add("applied_name_assignment");
			types.add("applied_organizational_project_assignment");
			types.add("applied_organization_assignment");
			types.add("applied_person_and_organization_assignment");
			types.add("applied_presented_item");
			types.add("applied_security_classification_assignment");
			types.add("applied_time_interval_assignment");
			types.add("approval");
			types.add("approval_assignment");
			types.add("approval_date_time");
			types.add("approval_person_organization");
			types.add("approval_relationship");
			types.add("approval_role");
			types.add("approval_status");
			types.add("approximation_tolerance");
			types.add("approximation_tolerance_deviation");
			types.add("approximation_tolerance_parameter");
			types.add("area_in_set");
			types.add("area_measure_with_unit");
			types.add("area_unit");
			types.add("asin_function");
			types.add("assembly_component_usage");
			types.add("assembly_component_usage_substitute");
			types.add("atan_function");
			types.add("attribute_classification_assignment");
			types.add("attribute_language_assignment");
			types.add("attribute_value_assignment");
			types.add("attribute_value_role");
			types.add("axis1_placement");
			types.add("axis2_placement_2d");
			types.add("axis2_placement_3d");
			types.add("background_colour");
			types.add("barring_hole");
			types.add("bead");
			types.add("bead_end");
			types.add("bezier_curve");
			types.add("bezier_surface");
			types.add("binary_boolean_expression");
			types.add("binary_function_call");
			types.add("binary_generic_expression");
			types.add("binary_numeric_expression");
			types.add("block");
			types.add("boolean_defined_function");
			types.add("boolean_expression");
			types.add("boolean_literal");
			types.add("boolean_result");
			types.add("boolean_variable");
			types.add("boss");
			types.add("boss_top");
			types.add("boundary_curve");
			types.add("bounded_curve");
			types.add("bounded_pcurve");
			types.add("bounded_surface");
			types.add("bounded_surface_curve");
			types.add("boxed_half_space");
			types.add("box_domain");
			types.add("brep_with_voids");
			types.add("b_spline_curve");
			types.add("b_spline_curve_with_knots");
			types.add("b_spline_surface");
			types.add("b_spline_surface_with_knots");
			types.add("calendar_date");
			types.add("camera_image");
			types.add("camera_image_2d_with_scale");
			types.add("camera_image_3d_with_scale");
			types.add("camera_model");
			types.add("camera_model_d2");
			types.add("camera_model_d3");
			types.add("camera_model_d3_with_hlhsr");
			types.add("camera_usage");
			types.add("cartesian_point");
			types.add("cartesian_transformation_operator");
			types.add("cartesian_transformation_operator_2d");
			types.add("cartesian_transformation_operator_3d");
			types.add("celsius_temperature_measure_with_unit");
			types.add("centre_of_symmetry");
			types.add("certification");
			types.add("certification_assignment");
			types.add("certification_type");
			types.add("chamfer");
			types.add("chamfer_offset");
			types.add("characterized_class");
			types.add("characterized_object");
			types.add("character_glyph_symbol");
			types.add("circle");
			types.add("circular_closed_profile");
			types.add("circular_pattern");
			types.add("circular_runout_tolerance");
			types.add("class");
			types.add("classification_assignment");
			types.add("classification_role");
			types.add("class_system");
			types.add("class_usage_effectivity_context_assignment");
			types.add("closed_path_profile");
			types.add("closed_shell");
			types.add("coaxiality_tolerance");
			types.add("colour");
			types.add("colour_rgb");
			types.add("colour_specification");
			types.add("common_datum");
			types.add("comparison_equal");
			types.add("comparison_expression");
			types.add("comparison_greater");
			types.add("comparison_greater_equal");
			types.add("comparison_less");
			types.add("comparison_less_equal");
			types.add("comparison_not_equal");
			types.add("composite_curve");
			types.add("composite_curve_on_surface");
			types.add("composite_curve_segment");
			types.add("composite_hole");
			types.add("composite_shape_aspect");
			types.add("composite_text");
			types.add("composite_text_with_associated_curves");
			types.add("composite_text_with_blanking_box");
			types.add("composite_text_with_extent");
			types.add("compound_feature");
			types.add("compound_representation_item");
			types.add("compound_shape_representation");
			types.add("concat_expression");
			types.add("concentricity_tolerance");
			types.add("concept_feature_operator");
			types.add("concept_feature_relationship");
			types.add("concept_feature_relationship_with_condition");
			types.add("conditional_concept_feature");
			types.add("configurable_item");
			types.add("configuration_definition");
			types.add("configuration_design");
			types.add("configuration_effectivity");
			types.add("configuration_interpolation");
			types.add("configuration_item");
			types.add("configured_effectivity_assignment");
			types.add("configured_effectivity_context_assignment");
			types.add("conic");
			types.add("conical_surface");
			types.add("connected_edge_set");
			types.add("connected_face_set");
			types.add("connected_face_sub_set");
			types.add("constructive_geometry_representation");
			types.add("constructive_geometry_representation_relationship");
			types.add("contact_ratio_representation");
			types.add("context_dependent_invisibility");
			types.add("context_dependent_over_riding_styled_item");
			types.add("context_dependent_shape_representation");
			types.add("context_dependent_unit");
			types.add("contract");
			types.add("contract_assignment");
			types.add("contract_type");
			types.add("conversion_based_unit");
			types.add("coordinated_universal_time_offset");
			types.add("cos_function");
			types.add("csg_shape_representation");
			types.add("csg_solid");
			types.add("curve");
			types.add("curve_bounded_surface");
			types.add("curve_dimension");
			types.add("curve_replica");
			types.add("curve_style");
			types.add("curve_style_font");
			types.add("curve_style_font_pattern");
			types.add("curve_style_rendering");
			types.add("curve_swept_solid_shape_representation");
			types.add("cylindrical_pair");
			types.add("cylindrical_pair_range");
			types.add("cylindrical_pair_value");
			types.add("cylindrical_surface");
			types.add("cylindricity_tolerance");
			types.add("data_environment");
			types.add("date");
			types.add("dated_effectivity");
			types.add("date_and_time");
			types.add("date_and_time_assignment");
			types.add("date_assignment");
			types.add("date_role");
			types.add("date_time_role");
			types.add("datum");
			types.add("datum_feature");
			types.add("datum_feature_callout");
			types.add("datum_reference");
			types.add("datum_target");
			types.add("datum_target_callout");
			types.add("default_tolerance_table");
			types.add("default_tolerance_table_cell");
			types.add("defined_character_glyph");
			types.add("defined_function");
			types.add("defined_symbol");
			types.add("definitional_representation");
			types.add("degenerate_pcurve");
			types.add("degenerate_toroidal_surface");
			types.add("derived_shape_aspect");
			types.add("derived_unit");
			types.add("derived_unit_element");
			types.add("derived_unit_variable");
			types.add("description_attribute");
			types.add("descriptive_representation_item");
			types.add("diameter_dimension");
			types.add("dimensional_characteristic_representation");
			types.add("dimensional_exponents");
			types.add("dimensional_location");
			types.add("dimensional_location_with_path");
			types.add("dimensional_size");
			types.add("dimensional_size_with_path");
			types.add("dimension_callout");
			types.add("dimension_callout_component_relationship");
			types.add("dimension_callout_relationship");
			types.add("dimension_curve");
			types.add("dimension_curve_directed_callout");
			types.add("dimension_curve_terminator");
			types.add("dimension_pair");
			types.add("dimension_related_tolerance_zone_element");
			types.add("dimension_text_associativity");
			types.add("directed_action");
			types.add("directed_angle");
			types.add("directed_dimensional_location");
			types.add("direction");
			types.add("direction_shape_representation");
			types.add("div_expression");
			types.add("document");
			types.add("document_file");
			types.add("document_product_association");
			types.add("document_product_equivalence");
			types.add("document_reference");
			types.add("document_relationship");
			types.add("document_representation_type");
			types.add("document_type");
			types.add("document_usage_constraint");
			types.add("document_usage_constraint_assignment");
			types.add("document_usage_role");
			types.add("draughting_annotation_occurrence");
			types.add("draughting_callout");
			types.add("draughting_callout_relationship");
			types.add("draughting_elements");
			types.add("draughting_model");
			types.add("draughting_model_item_association");
			types.add("draughting_pre_defined_colour");
			types.add("draughting_pre_defined_curve_font");
			types.add("draughting_pre_defined_text_font");
			types.add("draughting_specification_reference");
			types.add("draughting_subfigure_representation");
			types.add("draughting_symbol_representation");
			types.add("draughting_text_literal_with_delineation");
			types.add("draughting_title");
			types.add("drawing_definition");
			types.add("drawing_revision");
			types.add("drawing_revision_sequence");
			types.add("drawing_sheet_layout");
			types.add("drawing_sheet_revision");
			types.add("drawing_sheet_revision_usage");
			types.add("edge");
			types.add("edge_based_wireframe_model");
			types.add("edge_based_wireframe_shape_representation");
			types.add("edge_curve");
			types.add("edge_loop");
			types.add("edge_round");
			types.add("effectivity");
			types.add("effectivity_assignment");
			types.add("effectivity_context_assignment");
			types.add("effectivity_context_role");
			types.add("effectivity_relationship");
			types.add("electric_current_measure_with_unit");
			types.add("electric_current_unit");
			types.add("elementary_surface");
			types.add("element_delivery");
			types.add("ellipse");
			types.add("environment");
			types.add("equals_expression");
			types.add("evaluated_degenerate_pcurve");
			types.add("event_occurrence");
			types.add("event_occurrence_assignment");
			types.add("event_occurrence_context_assignment");
			types.add("event_occurrence_context_role");
			types.add("event_occurrence_role");
			types.add("exclusive_product_concept_feature_category");
			types.add("executed_action");
			types.add("expression");
			types.add("expression_conversion_based_unit");
			types.add("exp_function");
			types.add("extension");
			types.add("externally_defined_character_glyph");
			types.add("externally_defined_class");
			types.add("externally_defined_curve_font");
			types.add("externally_defined_dimension_definition");
			types.add("externally_defined_feature_definition");
			types.add("externally_defined_general_property");
			types.add("externally_defined_hatch_style");
			types.add("externally_defined_item");
			types.add("externally_defined_item_relationship");
			types.add("externally_defined_style");
			types.add("externally_defined_symbol");
			types.add("externally_defined_text_font");
			types.add("externally_defined_tile_style");
			types.add("external_identification_assignment");
			types.add("external_source");
			types.add("extruded_area_solid");
			types.add("extruded_face_solid");
			types.add("face");
			types.add("faceted_brep");
			types.add("faceted_brep_shape_representation");
			types.add("face_based_surface_model");
			types.add("face_bound");
			types.add("face_outer_bound");
			types.add("face_shape_representation");
			types.add("face_surface");
			types.add("featured_shape");
			types.add("feature_component_definition");
			types.add("feature_component_relationship");
			types.add("feature_definition");
			types.add("feature_in_panel");
			types.add("feature_pattern");
			types.add("fillet");
			types.add("fill_area_style");
			types.add("fill_area_style_colour");
			types.add("fill_area_style_hatching");
			types.add("fill_area_style_tiles");
			types.add("fill_area_style_tile_symbol_with_style");
			types.add("flatness_tolerance");
			types.add("format_function");
			types.add("founded_item");
			types.add("founded_kinematic_path");
			types.add("fully_constrained_pair");
			types.add("functionally_defined_transformation");
			types.add("gear_pair");
			types.add("gear_pair_range");
			types.add("gear_pair_value");
			types.add("general_feature");
			types.add("general_material_property");
			types.add("general_property");
			types.add("general_property_association");
			types.add("general_property_relationship");
			types.add("generic_expression");
			types.add("generic_character_glyph_symbol");
			types.add("generic_literal");
			types.add("generic_variable");
			types.add("geometrically_bounded_2d_wireframe_representation");
			types.add("geometrically_bounded_surface_shape_representation");
			types.add("geometrically_bounded_wireframe_shape_representation");
			types.add("geometrical_tolerance_callout");
			types.add("geometric_alignment");
			types.add("geometric_curve_set");
			types.add("geometric_intersection");
			types.add("geometric_item_specific_usage");
			types.add("geometric_representation_context");
			types.add("geometric_representation_item");
			types.add("geometric_set");
			types.add("geometric_tolerance");
			types.add("geometric_tolerance_relationship");
			types.add("geometric_tolerance_with_datum_reference");
			types.add("geometric_tolerance_with_defined_unit");
			types.add("global_uncertainty_assigned_context");
			types.add("global_unit_assigned_context");
			types.add("group");
			types.add("group_assignment");
			types.add("group_relationship");
			types.add("half_space_solid");
			types.add("hardness_representation");
			types.add("hidden_element_over_riding_styled_item");
			types.add("hole_bottom");
			types.add("hole_in_panel");
			types.add("homokinetic_pair");
			types.add("hyperbola");
			types.add("identification_assignment");
			types.add("identification_role");
			types.add("id_attribute");
			types.add("inclusion_product_concept_feature");
			types.add("index_expression");
			types.add("initial_state");
			types.add("instanced_feature");
			types.add("integer_defined_function");
			types.add("interpolated_configuration_sequence");
			types.add("intersection_curve");
			types.add("interval_expression");
			types.add("int_literal");
			types.add("int_numeric_variable");
			types.add("int_value_function");
			types.add("invisibility");
			types.add("item_defined_transformation");
			types.add("item_identified_representation_usage");
			types.add("joggle");
			types.add("joggle_termination");
			types.add("kinematic_analysis_consistency");
			types.add("kinematic_analysis_result");
			types.add("kinematic_control");
			types.add("kinematic_frame_background_representation");
			types.add("kinematic_frame_background_representation_association");
			types.add("kinematic_frame_based_transformation");
			types.add("kinematic_ground_representation");
			types.add("kinematic_joint");
			types.add("kinematic_link");
			types.add("kinematic_link_representation");
			types.add("kinematic_link_representation_association");
			types.add("kinematic_link_representation_relation");
			types.add("kinematic_pair");
			types.add("kinematic_path");
			types.add("kinematic_property_definition");
			types.add("kinematic_property_representation_relation");
			types.add("kinematic_structure");
			types.add("known_source");
			types.add("language");
			types.add("language_assignment");
			types.add("leader_curve");
			types.add("leader_directed_callout");
			types.add("leader_directed_dimension");
			types.add("leader_terminator");
			types.add("length_function");
			types.add("length_measure_with_unit");
			types.add("length_unit");
			types.add("light_source");
			types.add("light_source_ambient");
			types.add("light_source_directional");
			types.add("light_source_positional");
			types.add("light_source_spot");
			types.add("like_expression");
			types.add("limits_and_fits");
			types.add("line");
			types.add("linear_dimension");
			types.add("line_profile_tolerance");
			types.add("literal_number");
			types.add("local_time");
			types.add("location_shape_representation");
			types.add("locator");
			types.add("log10_function");
			types.add("log2_function");
			types.add("log_function");
			types.add("loop");
			types.add("lot_effectivity");
			types.add("luminous_intensity_measure_with_unit");
			types.add("luminous_intensity_unit");
			types.add("make_from_usage_option");
			types.add("manifold_solid_brep");
			types.add("manifold_subsurface_shape_representation");
			types.add("manifold_surface_shape_representation");
			types.add("mapped_item");
			types.add("mass_measure_with_unit");
			types.add("mass_unit");
			types.add("material_designation");
			types.add("material_designation_characterization");
			types.add("material_property");
			types.add("material_property_representation");
			types.add("maximum_function");
			types.add("measure_qualification");
			types.add("measure_representation_item");
			types.add("measure_with_unit");
			types.add("mechanical_design_geometric_presentation_area");
			types.add("mechanical_design_geometric_presentation_representation");
			types.add("mechanism");
			types.add("mechanism_base_placement");
			types.add("minimum_function");
			types.add("minus_expression");
			types.add("minus_function");
			types.add("modified_geometric_tolerance");
			types.add("modified_pattern");
			types.add("mod_expression");
			types.add("moments_of_inertia_representation");
			types.add("motion_link_relationship");
			types.add("multiple_arity_boolean_expression");
			types.add("multiple_arity_function_call");
			types.add("multiple_arity_generic_expression");
			types.add("multiple_arity_numeric_expression");
			types.add("multi_language_attribute_assignment");
			types.add("mult_expression");
			types.add("named_unit");
			types.add("named_unit_variable");
			types.add("name_assignment");
			types.add("name_attribute");
			types.add("next_assembly_usage_occurrence");
			types.add("ngon_closed_profile");
			types.add("non_manifold_surface_shape_representation");
			types.add("not_expression");
			types.add("numeric_defined_function");
			types.add("numeric_expression");
			types.add("numeric_variable");
			types.add("object_role");
			types.add("odd_function");
			types.add("offset_curve_2d");
			types.add("offset_curve_3d");
			types.add("offset_surface");
			types.add("one_direction_repeat_factor");
			types.add("open_path_profile");
			types.add("open_shell");
			types.add("ordinate_dimension");
			types.add("organization");
			types.add("organizational_address");
			types.add("organizational_project");
			types.add("organizational_project_assignment");
			types.add("organizational_project_relationship");
			types.add("organizational_project_role");
			types.add("organization_assignment");
			types.add("organization_relationship");
			types.add("organization_role");
			types.add("oriented_closed_shell");
			types.add("oriented_edge");
			types.add("oriented_face");
			types.add("oriented_open_shell");
			types.add("oriented_path");
			types.add("oriented_surface");
			types.add("or_expression");
			types.add("outer_boundary_curve");
			types.add("over_riding_styled_item");
			types.add("package_product_concept_feature");
			types.add("pair_actuator");
			types.add("pair_value");
			types.add("parabola");
			types.add("parallelism_tolerance");
			types.add("parallel_offset");
			types.add("parametric_representation_context");
			types.add("partial_circular_profile");
			types.add("path");
			types.add("path_feature_component");
			types.add("path_shape_representation");
			types.add("pattern_offset_membership");
			types.add("pattern_omit_membership");
			types.add("pcurve");
			types.add("perpendicularity_tolerance");
			types.add("perpendicular_to");
			types.add("person");
			types.add("personal_address");
			types.add("person_and_organization");
			types.add("person_and_organization_address");
			types.add("person_and_organization_assignment");
			types.add("person_and_organization_role");
			types.add("physically_modelled_product_definition");
			types.add("placed_datum_target_feature");
			types.add("placed_feature");
			types.add("placement");
			types.add("planar_box");
			types.add("planar_curve_pair");
			types.add("planar_curve_pair_range");
			types.add("planar_extent");
			types.add("planar_pair");
			types.add("planar_pair_range");
			types.add("planar_pair_value");
			types.add("planar_shape_representation");
			types.add("plane");
			types.add("plane_angle_measure_with_unit");
			types.add("plane_angle_unit");
			types.add("plus_expression");
			types.add("plus_minus_tolerance");
			types.add("pocket");
			types.add("pocket_bottom");
			types.add("point");
			types.add("point_on_curve");
			types.add("point_on_planar_curve_pair");
			types.add("point_on_planar_curve_pair_range");
			types.add("point_on_planar_curve_pair_value");
			types.add("point_on_surface");
			types.add("point_on_surface_pair");
			types.add("point_on_surface_pair_range");
			types.add("point_on_surface_pair_value");
			types.add("point_placement_shape_representation");
			types.add("point_replica");
			types.add("point_style");
			types.add("polyline");
			types.add("poly_loop");
			types.add("position_tolerance");
			types.add("power_expression");
			types.add("precision_qualifier");
			types.add("presentation_area");
			types.add("presentation_layer_assignment");
			types.add("presentation_representation");
			types.add("presentation_set");
			types.add("presentation_size");
			types.add("presentation_style_assignment");
			types.add("presentation_style_by_context");
			types.add("presentation_view");
			types.add("presented_item");
			types.add("presented_item_representation");
			types.add("pre_defined_colour");
			types.add("pre_defined_curve_font");
			types.add("pre_defined_dimension_symbol");
			types.add("pre_defined_geometrical_tolerance_symbol");
			types.add("pre_defined_item");
			types.add("pre_defined_marker");
			types.add("pre_defined_point_marker_symbol");
			types.add("pre_defined_presentation_style");
			types.add("pre_defined_surface_condition_symbol");
			types.add("pre_defined_symbol");
			types.add("pre_defined_terminator_symbol");
			types.add("pre_defined_text_font");
			types.add("prismatic_pair");
			types.add("prismatic_pair_range");
			types.add("prismatic_pair_value");
			types.add("process_operation");
			types.add("process_plan");
			types.add("process_product_association");
			types.add("process_property_association");
			types.add("product");
			types.add("product_category");
			types.add("product_category_relationship");
			types.add("product_class");
			types.add("product_concept");
			types.add("product_concept_context");
			types.add("product_concept_feature");
			types.add("product_concept_feature_association");
			types.add("product_concept_feature_category");
			types.add("product_concept_feature_category_usage");
			types.add("product_concept_relationship");
			types.add("product_context");
			types.add("product_definition");
			types.add("product_definition_context");
			types.add("product_definition_context_association");
			types.add("product_definition_context_role");
			types.add("product_definition_effectivity");
			types.add("product_definition_formation");
			types.add("product_definition_formation_relationship");
			types.add("product_definition_formation_with_specified_source");
			types.add("product_definition_occurrence_relationship");
			types.add("product_definition_process");
			types.add("product_definition_relationship");
			types.add("product_definition_resource");
			types.add("product_definition_shape");
			types.add("product_definition_substitute");
			types.add("product_definition_usage");
			types.add("product_definition_with_associated_documents");
			types.add("product_identification");
			types.add("product_process_plan");
			types.add("product_related_product_category");
			types.add("product_specification");
			types.add("projected_zone_definition");
			types.add("projection_curve");
			types.add("projection_directed_callout");
			types.add("promissory_usage_occurrence");
			types.add("property_definition");
			types.add("property_definition_relationship");
			types.add("property_definition_representation");
			types.add("property_process");
			types.add("qualified_representation_item");
			types.add("qualitative_uncertainty");
			types.add("quantified_assembly_component_usage");
			types.add("quasi_uniform_curve");
			types.add("quasi_uniform_surface");
			types.add("rack_and_pinion_pair");
			types.add("rack_and_pinion_pair_range");
			types.add("rack_and_pinion_pair_value");
			types.add("radius_dimension");
			types.add("rational_b_spline_curve");
			types.add("rational_b_spline_surface");
			types.add("ratio_measure_with_unit");
			types.add("ratio_unit");
			types.add("real_defined_function");
			types.add("real_literal");
			types.add("real_numeric_variable");
			types.add("rectangular_closed_profile");
			types.add("rectangular_composite_surface");
			types.add("rectangular_pattern");
			types.add("rectangular_trimmed_surface");
			types.add("referenced_modified_datum");
			types.add("relative_event_occurrence");
			types.add("reparametrised_composite_curve_segment");
			types.add("replicate_feature");
			types.add("representation");
			types.add("representation_context");
			types.add("representation_item");
			types.add("representation_map");
			types.add("representation_relationship");
			types.add("representation_relationship_with_transformation");
			types.add("rep_item_group");
			types.add("requirement_for_action_resource");
			types.add("resource_property");
			types.add("resource_property_representation");
			types.add("resource_requirement_type");
			types.add("resulting_path");
			types.add("retention");
			types.add("revolute_pair");
			types.add("revolute_pair_range");
			types.add("revolute_pair_value");
			types.add("revolved_area_solid");
			types.add("revolved_face_solid");
			types.add("rib");
			types.add("right_angular_wedge");
			types.add("right_circular_cone");
			types.add("right_circular_cylinder");
			types.add("role_association");
			types.add("rolling_curve_pair");
			types.add("rolling_curve_pair_value");
			types.add("rolling_surface_pair");
			types.add("rolling_surface_pair_value");
			types.add("rotation_about_direction");
			types.add("rounded_u_profile");
			types.add("roundness_tolerance");
			types.add("round_hole");
			types.add("ruled_surface_swept_area_solid");
			types.add("runout_zone_definition");
			types.add("runout_zone_orientation");
			types.add("runout_zone_orientation_reference_direction");
			types.add("screw_pair");
			types.add("screw_pair_range");
			types.add("screw_pair_value");
			types.add("seam_curve");
			types.add("seam_edge");
			types.add("security_classification");
			types.add("security_classification_assignment");
			types.add("security_classification_level");
			types.add("serial_numbered_effectivity");
			types.add("shape_aspect");
			types.add("shape_aspect_associativity");
			types.add("shape_aspect_deriving_relationship");
			types.add("shape_aspect_relationship");
			types.add("shape_aspect_transition");
			types.add("shape_defining_relationship");
			types.add("shape_definition_representation");
			types.add("shape_dimension_representation");
			types.add("shape_representation");
			types.add("shape_representation_relationship");
			types.add("shape_representation_with_parameters");
			types.add("shell_based_surface_model");
			types.add("simple_boolean_expression");
			types.add("simple_generic_expression");
			types.add("simple_numeric_expression");
			types.add("simple_pair_range");
			types.add("simple_string_expression");
			types.add("sin_function");
			types.add("si_unit");
			types.add("slash_expression");
			types.add("sliding_curve_pair");
			types.add("sliding_curve_pair_value");
			types.add("sliding_surface_pair");
			types.add("sliding_surface_pair_value");
			types.add("slot");
			types.add("slot_end");
			types.add("solid_angle_measure_with_unit");
			types.add("solid_angle_unit");
			types.add("solid_model");
			types.add("solid_replica");
			types.add("specified_higher_usage_occurrence");
			types.add("sphere");
			types.add("spherical_pair");
			types.add("spherical_pair_range");
			types.add("spherical_pair_value");
			types.add("spherical_surface");
			types.add("sql_mappable_defined_function");
			types.add("square_root_function");
			types.add("square_u_profile");
			types.add("standard_uncertainty");
			types.add("straightness_tolerance");
			types.add("string_defined_function");
			types.add("string_expression");
			types.add("string_literal");
			types.add("string_variable");
			types.add("structured_dimension_callout");
			types.add("styled_item");
			types.add("subedge");
			types.add("subface");
			types.add("substring_expression");
			types.add("surface");
			types.add("surface_condition_callout");
			types.add("surface_curve");
			types.add("surface_curve_swept_area_solid");
			types.add("surface_of_linear_extrusion");
			types.add("surface_of_revolution");
			types.add("surface_pair");
			types.add("surface_pair_range");
			types.add("surface_patch");
			types.add("surface_profile_tolerance");
			types.add("surface_rendering_properties");
			types.add("surface_replica");
			types.add("surface_side_style");
			types.add("surface_style_boundary");
			types.add("surface_style_control_grid");
			types.add("surface_style_fill_area");
			types.add("surface_style_parameter_line");
			types.add("surface_style_reflectance_ambient");
			types.add("surface_style_reflectance_ambient_diffuse");
			types.add("surface_style_reflectance_ambient_diffuse_specular");
			types.add("surface_style_rendering");
			types.add("surface_style_rendering_with_properties");
			types.add("surface_style_segmentation_curve");
			types.add("surface_style_silhouette");
			types.add("surface_style_transparent");
			types.add("surface_style_usage");
			types.add("surface_texture_representation");
			types.add("swept_area_solid");
			types.add("swept_disk_solid");
			types.add("swept_face_solid");
			types.add("swept_surface");
			types.add("symbol_colour");
			types.add("symbol_representation");
			types.add("symbol_representation_map");
			types.add("symbol_style");
			types.add("symbol_target");
			types.add("symmetric_shape_aspect");
			types.add("symmetry_tolerance");
			types.add("tactile_appearance_representation");
			types.add("tangent");
			types.add("tan_function");
			types.add("taper");
			types.add("tee_profile");
			types.add("terminator_symbol");
			types.add("text_literal");
			types.add("text_literal_with_associated_curves");
			types.add("text_literal_with_blanking_box");
			types.add("text_literal_with_delineation");
			types.add("text_literal_with_extent");
			types.add("text_string_representation");
			types.add("text_style");
			types.add("text_style_for_defined_font");
			types.add("text_style_with_box_characteristics");
			types.add("text_style_with_mirror");
			types.add("text_style_with_spacing");
			types.add("thermodynamic_temperature_measure_with_unit");
			types.add("thermodynamic_temperature_unit");
			types.add("thread");
			types.add("time_interval");
			types.add("time_interval_assignment");
			types.add("time_interval_based_effectivity");
			types.add("time_interval_role");
			types.add("time_interval_with_bounds");
			types.add("time_measure_with_unit");
			types.add("time_unit");
			types.add("tolerance_value");
			types.add("tolerance_zone");
			types.add("tolerance_zone_definition");
			types.add("tolerance_zone_form");
			types.add("topological_representation_item");
			types.add("toroidal_surface");
			types.add("torus");
			types.add("total_runout_tolerance");
			types.add("transition_feature");
			types.add("trimmed_curve");
			types.add("two_direction_repeat_factor");
			types.add("type_qualifier");
			types.add("unary_boolean_expression");
			types.add("unary_function_call");
			types.add("unary_generic_expression");
			types.add("unary_numeric_expression");
			types.add("uncertainty_assigned_representation");
			types.add("uncertainty_measure_with_unit");
			types.add("uncertainty_qualifier");
			types.add("unconstrained_pair");
			types.add("unconstrained_pair_value");
			types.add("uniform_curve");
			types.add("uniform_surface");
			types.add("universal_pair");
			types.add("universal_pair_range");
			types.add("universal_pair_value");
			types.add("value_function");
			types.add("value_range");
			types.add("value_representation_item");
			types.add("variable");
			types.add("variable_semantics");
			types.add("vector");
			types.add("vector_style");
			types.add("vee_profile");
			types.add("versioned_action_request");
			types.add("versioned_action_request_relationship");
			types.add("vertex");
			types.add("vertex_loop");
			types.add("vertex_point");
			types.add("view_volume");
			types.add("visual_appearance_representation");
			types.add("volume_measure_with_unit");
			types.add("volume_unit");
			types.add("xor_expression");
		}
}
