/*
 * $Id: AP242Entities.java,v 1.1 2012/01/02 16:28:23 raira Exp $
 *
 * JSDAI(TM), a way to implement STEP, ISO 10303
 * Copyright (C) 1997-2009, LKSoftWare GmbH, Germany
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License
 * version 3 as published by the Free Software Foundation (AGPL v3).
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * JSDAI is a registered trademark of LKSoftWare GmbH, Germany
 * This software is also available under commercial licenses.
 * See also http://www.jsdai.net/
 */

package jsdaix.processor.xim_aim.util;

import java.util.TreeSet;

public class AP242Entities extends APInstancesProcessor {

		private AP242Entities() { }
		
		private static AP242Entities INSTANCE;
		
		public static AP242Entities getInstance(){
				if(INSTANCE == null){
						INSTANCE = new AP242Entities();
						createDictionary();
				}
				return INSTANCE;
		}
		
		private static void createDictionary(){
			types = new TreeSet();
			types.add("abrupt_change_of_surface_normal");
			types.add("abs_function");
			types.add("absorbed_dose_measure_with_unit");
			types.add("absorbed_dose_unit");
			types.add("abstract_variable");
			types.add("abstracted_expression_function");
			types.add("acceleration_measure_with_unit");
			types.add("acceleration_unit");
			types.add("acos_function");
			types.add("action");
			types.add("action_assignment");
			types.add("action_directive");
			types.add("action_method");
			types.add("action_method_assignment");
			types.add("action_method_relationship");
			types.add("action_method_role");
			types.add("action_property");
			types.add("action_property_representation");
			types.add("action_relationship");
			types.add("action_request_assignment");
			types.add("action_request_solution");
			types.add("action_request_status");
			types.add("action_resource");
			types.add("action_resource_requirement");
			types.add("action_resource_type");
			types.add("action_status");
			types.add("actuated_kinematic_pair");
			types.add("add_element");
			types.add("address");
			types.add("advanced_brep_shape_representation");
			types.add("advanced_face");
			types.add("agc_with_dimension");
			types.add("all_around_shape_aspect");
			types.add("alternate_product_relationship");
			types.add("amount_of_substance_measure_with_unit");
			types.add("amount_of_substance_unit");
			types.add("and_expression");
			types.add("angle_assembly_constraint_with_dimension");
			types.add("angle_direction_reference");
			types.add("angle_geometric_constraint");
			types.add("angular_dimension");
			types.add("angular_location");
			types.add("angular_size");
			types.add("angularity_tolerance");
			types.add("annotation_curve_occurrence");
			types.add("annotation_fill_area");
			types.add("annotation_fill_area_occurrence");
			types.add("annotation_occurrence");
			types.add("annotation_occurrence_associativity");
			types.add("annotation_occurrence_relationship");
			types.add("annotation_plane");
			types.add("annotation_subfigure_occurrence");
			types.add("annotation_symbol");
			types.add("annotation_symbol_occurrence");
			types.add("annotation_text");
			types.add("annotation_text_character");
			types.add("annotation_text_occurrence");
			types.add("apex");
			types.add("application_context");
			types.add("application_context_element");
			types.add("application_defined_function");
			types.add("application_protocol_definition");
			types.add("applied_action_assignment");
			types.add("applied_action_method_assignment");
			types.add("applied_action_request_assignment");
			types.add("applied_approval_assignment");
			types.add("applied_area");
			types.add("applied_attribute_classification_assignment");
			types.add("applied_certification_assignment");
			types.add("applied_classification_assignment");
			types.add("applied_contract_assignment");
			types.add("applied_date_and_time_assignment");
			types.add("applied_date_assignment");
			types.add("applied_document_reference");
			types.add("applied_document_usage_constraint_assignment");
			types.add("applied_effectivity_assignment");
			types.add("applied_event_occurrence_assignment");
			types.add("applied_external_identification_assignment");
			types.add("applied_group_assignment");
			types.add("applied_identification_assignment");
			types.add("applied_ineffectivity_assignment");
			types.add("applied_name_assignment");
			types.add("applied_organization_assignment");
			types.add("applied_organizational_project_assignment");
			types.add("applied_person_and_organization_assignment");
			types.add("applied_presented_item");
			types.add("applied_security_classification_assignment");
			types.add("applied_time_interval_assignment");
			types.add("applied_usage_right");
			types.add("approval");
			types.add("approval_assignment");
			types.add("approval_date_time");
			types.add("approval_person_organization");
			types.add("approval_relationship");
			types.add("approval_role");
			types.add("approval_status");
			types.add("area_in_set");
			types.add("area_measure_with_unit");
			types.add("area_unit");
			types.add("area_with_outer_boundary");
			types.add("array_placement_group");
			types.add("asin_function");
			types.add("assembly_bond_definition");
			types.add("assembly_component");
			types.add("assembly_component_usage");
			types.add("assembly_component_usage_substitute");
			types.add("assembly_geometric_constraint");
			types.add("assembly_group_component");
			types.add("assembly_group_component_definition_placement_link");
			types.add("assembly_joint");
			types.add("assigned_requirement");
			types.add("atan_function");
			types.add("atom_based_literal");
			types.add("atomic_formula");
			types.add("attribute_assertion");
			types.add("attribute_classification_assignment");
			types.add("attribute_language_assignment");
			types.add("attribute_value_assignment");
			types.add("attribute_value_role");
			types.add("auxiliary_geometric_representation_item");
			types.add("axis1_placement");
			types.add("axis2_placement_2d");
			types.add("axis2_placement_3d");
			types.add("b_spline_basis");
			types.add("b_spline_curve");
			types.add("b_spline_curve_knot_locator");
			types.add("b_spline_curve_segment");
			types.add("b_spline_curve_with_knots");
			types.add("b_spline_function");
			types.add("b_spline_surface");
			types.add("b_spline_surface_knot_locator");
			types.add("b_spline_surface_patch");
			types.add("b_spline_surface_strip");
			types.add("b_spline_surface_with_knots");
			types.add("back_chaining_rule");
			types.add("back_chaining_rule_body");
			types.add("background_colour");
			types.add("barring_hole");
			types.add("basic_sparse_matrix");
			types.add("bead");
			types.add("bead_end");
			types.add("between_shape_aspect");
			types.add("beveled_sheet_representation");
			types.add("bezier_curve");
			types.add("bezier_surface");
			types.add("binary_assembly_constraint");
			types.add("binary_boolean_expression");
			types.add("binary_function_call");
			types.add("binary_generic_expression");
			types.add("binary_literal");
			types.add("binary_numeric_expression");
			types.add("binary_representation_item");
			types.add("block");
			types.add("boolean_defined_function");
			types.add("boolean_expression");
			types.add("boolean_literal");
			types.add("boolean_representation_item");
			types.add("boolean_result");
			types.add("boolean_result_2d");
			types.add("boolean_variable");
			types.add("boss");
			types.add("boss_top");
			types.add("bound_parameter_environment");
			types.add("bound_variational_parameter");
			types.add("boundary_curve");
			types.add("boundary_curve_of_b_spline_or_rectangular_composite_surface");
			types.add("bounded_curve");
			types.add("bounded_pcurve");
			types.add("bounded_surface");
			types.add("bounded_surface_curve");
			types.add("box_domain");
			types.add("boxed_half_space");
			types.add("breakdown_context");
			types.add("breakdown_element_group_assignment");
			types.add("breakdown_element_realization");
			types.add("breakdown_element_usage");
			types.add("breakdown_of");
			types.add("brep_with_voids");
			types.add("bytes_representation_item");
			types.add("calendar_date");
			types.add("camera_image");
			types.add("camera_image_2d_with_scale");
			types.add("camera_image_3d_with_scale");
			types.add("camera_model");
			types.add("camera_model_d2");
			types.add("camera_model_d3");
			types.add("camera_model_d3_multi_clipping");
			types.add("camera_model_d3_multi_clipping_intersection");
			types.add("camera_model_d3_multi_clipping_union");
			types.add("camera_model_d3_with_hlhsr");
			types.add("camera_model_with_light_sources");
			types.add("camera_usage");
			types.add("capacitance_measure_with_unit");
			types.add("capacitance_unit");
			types.add("cartesian_complex_number_region");
			types.add("cartesian_point");
			types.add("cartesian_transformation_operator");
			types.add("cartesian_transformation_operator_2d");
			types.add("cartesian_transformation_operator_3d");
			types.add("cc_design_approval");
			types.add("cc_design_certification");
			types.add("cc_design_contract");
			types.add("cc_design_date_and_time_assignment");
			types.add("cc_design_person_and_organization_assignment");
			types.add("cc_design_security_classification");
			types.add("cc_design_specification_reference");
			types.add("cdgc_with_dimension");
			types.add("celsius_temperature_measure_with_unit");
			types.add("centre_of_symmetry");
			types.add("certification");
			types.add("certification_assignment");
			types.add("certification_type");
			types.add("chain_based_geometric_item_specific_usage");
			types.add("chain_based_item_identified_representation_usage");
			types.add("chamfer");
			types.add("chamfer_offset");
			types.add("change");
			types.add("change_composition_relationship");
			types.add("change_element");
			types.add("change_element_sequence");
			types.add("change_group");
			types.add("change_group_assignment");
			types.add("change_request");
			types.add("character_glyph_font_usage");
			types.add("character_glyph_style_outline");
			types.add("character_glyph_style_stroke");
			types.add("character_glyph_symbol");
			types.add("character_glyph_symbol_outline");
			types.add("character_glyph_symbol_stroke");
			types.add("characteristic_data_column_header");
			types.add("characteristic_data_column_header_link");
			types.add("characteristic_data_table_header");
			types.add("characteristic_data_table_header_decomposition");
			types.add("characteristic_type");
			types.add("characterized_chain_based_item_within_representation");
			types.add("characterized_class");
			types.add("characterized_item_within_representation");
			types.add("characterized_object");
			types.add("characterized_representation");
			types.add("circle");
			types.add("circular_area");
			types.add("circular_closed_profile");
			types.add("circular_path");
			types.add("circular_pattern");
			types.add("circular_runout_tolerance");
			types.add("class");
			types.add("class_by_extension");
			types.add("class_by_intension");
			types.add("class_system");
			types.add("class_usage_effectivity_context_assignment");
			types.add("classification_assignment");
			types.add("classification_role");
			types.add("clgc_with_dimension");
			types.add("closed_curve_style_parameters");
			types.add("closed_path_profile");
			types.add("closed_shell");
			types.add("coaxial_assembly_constraint");
			types.add("coaxial_geometric_constraint");
			types.add("coaxiality_tolerance");
			types.add("colour");
			types.add("colour_rgb");
			types.add("colour_specification");
			types.add("common_datum");
			types.add("comparison_equal");
			types.add("comparison_expression");
			types.add("comparison_greater");
			types.add("comparison_greater_equal");
			types.add("comparison_less");
			types.add("comparison_less_equal");
			types.add("comparison_not_equal");
			types.add("complex_area");
			types.add("complex_clause");
			types.add("complex_conjunctive_clause");
			types.add("complex_disjunctive_clause");
			types.add("complex_number_literal");
			types.add("complex_shelled_solid");
			types.add("component_definition");
			types.add("component_feature");
			types.add("component_feature_joint");
			types.add("component_feature_relationship");
			types.add("component_mating_constraint_condition");
			types.add("component_terminal");
			types.add("composite_assembly_sequence_definition");
			types.add("composite_assembly_table");
			types.add("composite_curve");
			types.add("composite_curve_on_surface");
			types.add("composite_curve_segment");
			types.add("composite_curve_transition_locator");
			types.add("composite_group_shape_aspect");
			types.add("composite_hole");
			types.add("composite_material_designation");
			types.add("composite_shape_aspect");
			types.add("composite_sheet_representation");
			types.add("composite_text");
			types.add("composite_text_with_associated_curves");
			types.add("composite_text_with_blanking_box");
			types.add("composite_text_with_delineation");
			types.add("composite_text_with_extent");
			types.add("composite_unit_shape_aspect");
			types.add("compound_feature");
			types.add("compound_representation_item");
			types.add("compound_shape_representation");
			types.add("concat_expression");
			types.add("concentricity_tolerance");
			types.add("concept_feature_operator");
			types.add("concept_feature_relationship");
			types.add("concept_feature_relationship_with_condition");
			types.add("conditional_concept_feature");
			types.add("conductance_measure_with_unit");
			types.add("conductance_unit");
			types.add("configurable_item");
			types.add("configuration_design");
			types.add("configuration_effectivity");
			types.add("configuration_item");
			types.add("configuration_item_hierarchical_relationship");
			types.add("configuration_item_relationship");
			types.add("configuration_item_revision_sequence");
			types.add("configured_effectivity_assignment");
			types.add("configured_effectivity_context_assignment");
			types.add("conic");
			types.add("conical_stepped_hole_transition");
			types.add("conical_surface");
			types.add("connected_edge_set");
			types.add("connected_face_set");
			types.add("connected_face_sub_set");
			types.add("connection_zone_based_assembly_joint");
			types.add("connection_zone_interface_plane_relationship");
			types.add("constant_function");
			types.add("constrained_kinematic_motion_representation");
			types.add("constructive_geometry_representation");
			types.add("constructive_geometry_representation_relationship");
			types.add("contact_ratio_representation");
			types.add("contacting_feature");
			types.add("context_dependent_invisibility");
			types.add("context_dependent_kinematic_link_representation");
			types.add("context_dependent_over_riding_styled_item");
			types.add("context_dependent_shape_representation");
			types.add("context_dependent_unit");
			types.add("continuous_shape_aspect");
			types.add("contract");
			types.add("contract_assignment");
			types.add("contract_relationship");
			types.add("contract_type");
			types.add("conversion_based_unit");
			types.add("coordinated_universal_time_offset");
			types.add("cos_function");
			types.add("csg_2d_shape_representation");
			types.add("csg_primitive_solid_2d");
			types.add("csg_shape_representation");
			types.add("csg_solid");
			types.add("csg_solid_2d");
			types.add("currency");
			types.add("currency_measure_with_unit");
			types.add("current_change_element_assignment");
			types.add("curve");
			types.add("curve_based_path");
			types.add("curve_based_path_with_orientation");
			types.add("curve_based_path_with_orientation_and_parameters");
			types.add("curve_bounded_surface");
			types.add("curve_dimension");
			types.add("curve_distance_geometric_constraint");
			types.add("curve_length_geometric_constraint");
			types.add("curve_replica");
			types.add("curve_segment_set");
			types.add("curve_smoothness_geometric_constraint");
			types.add("curve_style");
			types.add("curve_style_font");
			types.add("curve_style_font_and_scaling");
			types.add("curve_style_font_pattern");
			types.add("curve_style_parameters_representation");
			types.add("curve_style_parameters_with_ends");
			types.add("curve_style_rendering");
			types.add("curve_swept_solid_shape_representation");
			types.add("curve_with_excessive_segments");
			types.add("curve_with_small_curvature_radius");
			types.add("cylindrical_pair");
			types.add("cylindrical_pair_value");
			types.add("cylindrical_pair_with_range");
			types.add("cylindrical_surface");
			types.add("cylindricity_tolerance");
			types.add("data_environment");
			types.add("data_quality_assessment_measurement_association");
			types.add("data_quality_assessment_specification");
			types.add("data_quality_criteria_representation");
			types.add("data_quality_criterion");
			types.add("data_quality_criterion_assessment_association");
			types.add("data_quality_criterion_measurement_association");
			types.add("data_quality_definition");
			types.add("data_quality_definition_relationship");
			types.add("data_quality_definition_representation_relationship");
			types.add("data_quality_inspection_criterion_report");
			types.add("data_quality_inspection_criterion_report_item");
			types.add("data_quality_inspection_instance_report");
			types.add("data_quality_inspection_instance_report_item");
			types.add("data_quality_inspection_report");
			types.add("data_quality_inspection_result");
			types.add("data_quality_inspection_result_representation");
			types.add("data_quality_inspection_result_with_judgement");
			types.add("data_quality_measurement_requirement");
			types.add("data_quality_report_measurement_association");
			types.add("data_quality_report_request");
			types.add("date");
			types.add("date_and_time");
			types.add("date_and_time_assignment");
			types.add("date_assignment");
			types.add("date_representation_item");
			types.add("date_role");
			types.add("date_time_representation_item");
			types.add("date_time_role");
			types.add("dated_effectivity");
			types.add("datum");
			types.add("datum_feature");
			types.add("datum_feature_callout");
			types.add("datum_reference");
			types.add("datum_reference_compartment");
			types.add("datum_reference_element");
			types.add("datum_reference_modifier_with_value");
			types.add("datum_system");
			types.add("datum_target");
			types.add("datum_target_callout");
			types.add("default_tolerance_table");
			types.add("default_tolerance_table_cell");
			types.add("defined_character_glyph");
			types.add("defined_constraint");
			types.add("defined_function");
			types.add("defined_symbol");
			types.add("definite_integral_expression");
			types.add("definite_integral_function");
			types.add("definitional_representation");
			types.add("definitional_representation_relationship");
			types.add("definitional_representation_relationship_with_same_context");
			types.add("degenerate_pcurve");
			types.add("degenerate_toroidal_surface");
			types.add("delete_element");
			types.add("derived_shape_aspect");
			types.add("derived_unit");
			types.add("derived_unit_element");
			types.add("description_attribute");
			types.add("descriptive_representation_item");
			types.add("design_context");
			types.add("design_make_from_relationship");
			types.add("detailed_report_request");
			types.add("detailed_report_request_with_number_of_data");
			types.add("diameter_dimension");
			types.add("dielectric_constant_measure_with_unit");
			types.add("dimension_callout");
			types.add("dimension_callout_component_relationship");
			types.add("dimension_callout_relationship");
			types.add("dimension_curve");
			types.add("dimension_curve_directed_callout");
			types.add("dimension_curve_terminator");
			types.add("dimension_curve_terminator_to_projection_curve_associativity");
			types.add("dimension_pair");
			types.add("dimension_related_tolerance_zone_element");
			types.add("dimension_text_associativity");
			types.add("dimensional_characteristic_representation");
			types.add("dimensional_exponents");
			types.add("dimensional_location");
			types.add("dimensional_location_with_datum_feature");
			types.add("dimensional_location_with_path");
			types.add("dimensional_size");
			types.add("dimensional_size_with_datum_feature");
			types.add("dimensional_size_with_path");
			types.add("directed_action");
			types.add("directed_angle");
			types.add("directed_dimensional_location");
			types.add("direction");
			types.add("direction_shape_representation");
			types.add("disconnected_face_set");
			types.add("discontinuous_geometry");
			types.add("div_expression");
			types.add("document");
			types.add("document_file");
			types.add("document_identifier");
			types.add("document_identifier_assignment");
			types.add("document_product_association");
			types.add("document_product_equivalence");
			types.add("document_reference");
			types.add("document_relationship");
			types.add("document_representation_type");
			types.add("document_type");
			types.add("document_usage_constraint");
			types.add("document_usage_constraint_assignment");
			types.add("document_usage_role");
			types.add("dose_equivalent_measure_with_unit");
			types.add("dose_equivalent_unit");
			types.add("double_offset_shelled_solid");
			types.add("draped_defined_transformation");
			types.add("draughting_annotation_occurrence");
			types.add("draughting_callout");
			types.add("draughting_callout_relationship");
			types.add("draughting_elements");
			types.add("draughting_model");
			types.add("draughting_model_item_association");
			types.add("draughting_pre_defined_colour");
			types.add("draughting_pre_defined_curve_font");
			types.add("draughting_pre_defined_text_font");
			types.add("draughting_subfigure_representation");
			types.add("draughting_symbol_representation");
			types.add("draughting_text_literal_with_delineation");
			types.add("draughting_title");
			types.add("drawing_definition");
			types.add("drawing_revision");
			types.add("drawing_revision_sequence");
			types.add("drawing_sheet_layout");
			types.add("drawing_sheet_revision");
			types.add("drawing_sheet_revision_sequence");
			types.add("drawing_sheet_revision_usage");
			types.add("edge");
			types.add("edge_based_wireframe_model");
			types.add("edge_based_wireframe_shape_representation");
			types.add("edge_blended_solid");
			types.add("edge_curve");
			types.add("edge_loop");
			types.add("edge_round");
			types.add("edge_with_excessive_segments");
			types.add("effectivity");
			types.add("effectivity_assignment");
			types.add("effectivity_context_assignment");
			types.add("effectivity_context_role");
			types.add("effectivity_relationship");
			types.add("electric_charge_measure_with_unit");
			types.add("electric_charge_unit");
			types.add("electric_current_measure_with_unit");
			types.add("electric_current_unit");
			types.add("electric_potential_measure_with_unit");
			types.add("electric_potential_unit");
			types.add("elementary_brep_shape_representation");
			types.add("elementary_function");
			types.add("elementary_space");
			types.add("elementary_surface");
			types.add("ellipse");
			types.add("elliptic_area");
			types.add("energy_measure_with_unit");
			types.add("energy_unit");
			types.add("entirely_narrow_face");
			types.add("entirely_narrow_solid");
			types.add("entirely_narrow_surface");
			types.add("entity_assertion");
			types.add("enum_reference_prefix");
			types.add("environment");
			types.add("equal_parameter_constraint");
			types.add("equals_expression");
			types.add("erroneous_b_spline_curve_definition");
			types.add("erroneous_b_spline_surface_definition");
			types.add("erroneous_data");
			types.add("erroneous_geometry");
			types.add("erroneous_manifold_solid_brep");
			types.add("erroneous_topology");
			types.add("erroneous_topology_and_geometry_relationship");
			types.add("evaluated_characteristic");
			types.add("evaluated_degenerate_pcurve");
			types.add("evaluation_product_definition");
			types.add("event_occurrence");
			types.add("event_occurrence_assignment");
			types.add("event_occurrence_relationship");
			types.add("event_occurrence_role");
			types.add("excessively_high_degree_curve");
			types.add("excessively_high_degree_surface");
			types.add("exclusive_product_concept_feature_category");
			types.add("executed_action");
			types.add("exp_function");
			types.add("expanded_uncertainty");
			types.add("explicit_constraint");
			types.add("explicit_geometric_constraint");
			types.add("explicit_procedural_geometric_representation_item_relationship");
			types.add("explicit_procedural_representation_item_relationship");
			types.add("explicit_procedural_representation_relationship");
			types.add("explicit_procedural_shape_representation_relationship");
			types.add("explicit_table_function");
			types.add("expression");
			types.add("expression_conversion_based_unit");
			types.add("expression_denoted_function");
			types.add("extended_tuple_space");
			types.add("extension");
			types.add("extent");
			types.add("external_class_library");
			types.add("external_identification_assignment");
			types.add("external_source");
			types.add("external_source_relationship");
			types.add("externally_defined_character_glyph");
			types.add("externally_defined_class");
			types.add("externally_defined_colour");
			types.add("externally_defined_context_dependent_unit");
			types.add("externally_defined_conversion_based_unit");
			types.add("externally_defined_currency");
			types.add("externally_defined_curve_font");
			types.add("externally_defined_dimension_definition");
			types.add("externally_defined_feature_definition");
			types.add("externally_defined_general_property");
			types.add("externally_defined_hatch_style");
			types.add("externally_defined_item");
			types.add("externally_defined_item_relationship");
			types.add("externally_defined_marker");
			types.add("externally_defined_picture_representation_item");
			types.add("externally_defined_product_definition");
			types.add("externally_defined_representation_item");
			types.add("externally_defined_string");
			types.add("externally_defined_style");
			types.add("externally_defined_symbol");
			types.add("externally_defined_terminator_symbol");
			types.add("externally_defined_text_font");
			types.add("externally_defined_tile");
			types.add("externally_defined_tile_style");
			types.add("externally_listed_data");
			types.add("extreme_instance");
			types.add("extreme_patch_width_variation");
			types.add("extruded_area_solid");
			types.add("extruded_face_solid");
			types.add("extruded_face_solid_with_draft_angle");
			types.add("extruded_face_solid_with_multiple_draft_angles");
			types.add("extruded_face_solid_with_trim_conditions");
			types.add("face");
			types.add("face_based_surface_model");
			types.add("face_bound");
			types.add("face_outer_bound");
			types.add("face_shape_representation");
			types.add("face_shape_representation_relationship");
			types.add("face_surface");
			types.add("face_surface_with_excessive_patches_in_one_direction");
			types.add("faceted_brep");
			types.add("faceted_brep_shape_representation");
			types.add("fact_type");
			types.add("feature_component_definition");
			types.add("feature_component_relationship");
			types.add("feature_definition");
			types.add("feature_definition_with_connection_area");
			types.add("feature_for_datum_target_relationship");
			types.add("feature_in_panel");
			types.add("feature_pattern");
			types.add("fill_area_style");
			types.add("fill_area_style_colour");
			types.add("fill_area_style_hatching");
			types.add("fill_area_style_tile_coloured_region");
			types.add("fill_area_style_tile_curve_with_style");
			types.add("fill_area_style_tile_symbol_with_style");
			types.add("fill_area_style_tiles");
			types.add("fillet");
			types.add("finite_function");
			types.add("finite_integer_interval");
			types.add("finite_real_interval");
			types.add("finite_space");
			types.add("fixed_constituent_assembly_constraint");
			types.add("fixed_element_geometric_constraint");
			types.add("fixed_instance_attribute_set");
			types.add("flat_face");
			types.add("flat_pattern_ply_representation_relationship");
			types.add("flatness_tolerance");
			types.add("force_measure_with_unit");
			types.add("force_unit");
			types.add("format_function");
			types.add("forward_chaining_rule");
			types.add("forward_chaining_rule_premise");
			types.add("founded_item");
			types.add("free_edge");
			types.add("free_form_assignment");
			types.add("free_form_constraint");
			types.add("free_form_relation");
			types.add("free_kinematic_motion_representation");
			types.add("frequency_measure_with_unit");
			types.add("frequency_unit");
			types.add("frozen_assignment");
			types.add("fully_constrained_pair");
			types.add("func");
			types.add("function_application");
			types.add("function_space");
			types.add("functional_breakdown_context");
			types.add("functional_element_usage");
			types.add("functionally_defined_transformation");
			types.add("g1_discontinuity_between_adjacent_faces");
			types.add("g1_discontinuous_curve");
			types.add("g1_discontinuous_surface");
			types.add("g2_discontinuity_between_adjacent_faces");
			types.add("g2_discontinuous_curve");
			types.add("g2_discontinuous_surface");
			types.add("gap_between_adjacent_edges_in_loop");
			types.add("gap_between_edge_and_base_surface");
			types.add("gap_between_faces_related_to_an_edge");
			types.add("gap_between_pcurves_related_to_an_edge");
			types.add("gap_between_vertex_and_base_surface");
			types.add("gap_between_vertex_and_edge");
			types.add("gear");
			types.add("gear_pair");
			types.add("gear_pair_value");
			types.add("gear_pair_with_range");
			types.add("general_datum_reference");
			types.add("general_feature");
			types.add("general_linear_function");
			types.add("general_material_property");
			types.add("general_property");
			types.add("general_property_association");
			types.add("general_property_relationship");
			types.add("generated_finite_numeric_space");
			types.add("generic_character_glyph_symbol");
			types.add("generic_expression");
			types.add("generic_literal");
			types.add("generic_variable");
			types.add("geometric_alignment");
			types.add("geometric_contact");
			types.add("geometric_curve_set");
			types.add("geometric_gap_in_topology");
			types.add("geometric_intersection");
			types.add("geometric_item_specific_usage");
			types.add("geometric_model_element_relationship");
			types.add("geometric_representation_context");
			types.add("geometric_representation_context_with_parameter");
			types.add("geometric_representation_item");
			types.add("geometric_set");
			types.add("geometric_tolerance");
			types.add("geometric_tolerance_relationship");
			types.add("geometric_tolerance_with_datum_reference");
			types.add("geometric_tolerance_with_defined_area_unit");
			types.add("geometric_tolerance_with_defined_unit");
			types.add("geometric_tolerance_with_maximum_tolerance");
			types.add("geometric_tolerance_with_modifiers");
			types.add("geometrical_tolerance_callout");
			types.add("geometrically_bounded_2d_wireframe_representation");
			types.add("geometrically_bounded_surface_shape_representation");
			types.add("geometrically_bounded_wireframe_shape_representation");
			types.add("geometry_with_local_irregularity");
			types.add("geometry_with_local_near_degeneracy");
			types.add("global_assignment");
			types.add("global_uncertainty_assigned_context");
			types.add("global_unit_assigned_context");
			types.add("ground_fact");
			types.add("group");
			types.add("group_assignment");
			types.add("group_relationship");
			types.add("half_space_2d");
			types.add("half_space_solid");
			types.add("hardness_representation");
			types.add("hidden_element_over_riding_styled_item");
			types.add("high_degree_axi_symmetric_surface");
			types.add("high_degree_conic");
			types.add("high_degree_linear_curve");
			types.add("high_degree_planar_surface");
			types.add("high_order_kinematic_pair");
			types.add("hole_bottom");
			types.add("hole_in_panel");
			types.add("homogeneous_linear_function");
			types.add("homokinetic_pair");
			types.add("hyperbola");
			types.add("id_attribute");
			types.add("identification_assignment");
			types.add("identification_role");
			types.add("illuminance_measure_with_unit");
			types.add("illuminance_unit");
			types.add("implicit_explicit_positioned_sketch_relationship");
			types.add("implicit_intersection_curve");
			types.add("implicit_model_intersection_curve");
			types.add("implicit_planar_curve");
			types.add("implicit_planar_intersection_point");
			types.add("implicit_planar_projection_point");
			types.add("implicit_point_on_plane");
			types.add("implicit_projected_curve");
			types.add("implicit_silhouette_curve");
			types.add("imported_curve_function");
			types.add("imported_point_function");
			types.add("imported_surface_function");
			types.add("imported_volume_function");
			types.add("inapt_data");
			types.add("inapt_geometry");
			types.add("inapt_manifold_solid_brep");
			types.add("inapt_topology");
			types.add("inapt_topology_and_geometry_relationship");
			types.add("incidence_assembly_constraint");
			types.add("incidence_geometric_constraint");
			types.add("included_text_block");
			types.add("inclusion_product_concept_feature");
			types.add("inconsistent_adjacent_face_normals");
			types.add("inconsistent_curve_transition_code");
			types.add("inconsistent_edge_and_curve_directions");
			types.add("inconsistent_face_and_closed_shell_normals");
			types.add("inconsistent_face_and_surface_normals");
			types.add("inconsistent_surface_transition_code");
			types.add("index_expression");
			types.add("indirectly_selected_elements");
			types.add("indirectly_selected_shape_elements");
			types.add("indistinct_curve_knots");
			types.add("indistinct_surface_knots");
			types.add("inductance_measure_with_unit");
			types.add("inductance_unit");
			types.add("information_right");
			types.add("information_usage_right");
			types.add("instance_attribute_reference");
			types.add("instance_report_item_with_extreme_instances");
			types.add("instance_usage_context_assignment");
			types.add("instanced_feature");
			types.add("int_literal");
			types.add("int_numeric_variable");
			types.add("int_value_function");
			types.add("integer_defined_function");
			types.add("integer_interval_from_min");
			types.add("integer_interval_to_max");
			types.add("integer_representation_item");
			types.add("integer_tuple_literal");
			types.add("interfaced_group_component");
			types.add("interpolated_configuration_representation");
			types.add("interpolated_configuration_segment");
			types.add("interpolated_configuration_sequence");
			types.add("intersecting_connected_face_sets");
			types.add("intersecting_loops_in_face");
			types.add("intersecting_shells_in_solid");
			types.add("intersection_curve");
			types.add("interval_expression");
			types.add("invisibility");
			types.add("iso4217_currency");
			types.add("item_defined_transformation");
			types.add("item_identified_representation_usage");
			types.add("item_link_motion_relationship");
			types.add("joggle");
			types.add("joggle_termination");
			types.add("kinematic_analysis_consistency");
			types.add("kinematic_analysis_result");
			types.add("kinematic_control");
			types.add("kinematic_joint");
			types.add("kinematic_link");
			types.add("kinematic_link_representation");
			types.add("kinematic_link_representation_association");
			types.add("kinematic_loop");
			types.add("kinematic_pair");
			types.add("kinematic_path");
			types.add("kinematic_path_defined_by_curves");
			types.add("kinematic_path_defined_by_nodes");
			types.add("kinematic_path_segment");
			types.add("kinematic_property_definition_representation");
			types.add("kinematic_property_mechanism_representation");
			types.add("kinematic_property_topology_representation");
			types.add("kinematic_topology_directed_structure");
			types.add("kinematic_topology_network_structure");
			types.add("kinematic_topology_structure");
			types.add("kinematic_topology_substructure");
			types.add("kinematic_topology_tree_structure");
			types.add("known_source");
			types.add("laid_defined_transformation");
			types.add("laminate_table");
			types.add("language");
			types.add("leader_curve");
			types.add("leader_directed_callout");
			types.add("leader_directed_dimension");
			types.add("leader_terminator");
			types.add("length_function");
			types.add("length_measure_with_unit");
			types.add("length_unit");
			types.add("library_defined_product_definition");
			types.add("light_source");
			types.add("light_source_ambient");
			types.add("light_source_directional");
			types.add("light_source_positional");
			types.add("light_source_spot");
			types.add("like_expression");
			types.add("limits_and_fits");
			types.add("line");
			types.add("line_profile_tolerance");
			types.add("linear_array_component_definition_link");
			types.add("linear_array_placement_group_component");
			types.add("linear_dimension");
			types.add("linear_flexible_and_pinion_pair");
			types.add("linear_flexible_and_planar_curve_pair");
			types.add("linear_flexible_link_representation");
			types.add("linear_path");
			types.add("linear_profile");
			types.add("linearized_table_function");
			types.add("link_motion_relationship");
			types.add("link_motion_representation_along_path");
			types.add("link_motion_transformation");
			types.add("listed_data");
			types.add("listed_product_space");
			types.add("literal_conjunction");
			types.add("literal_disjunction");
			types.add("literal_number");
			types.add("local_time");
			types.add("location_in_aggregate_representation_item");
			types.add("location_shape_representation");
			types.add("locator");
			types.add("log10_function");
			types.add("log2_function");
			types.add("log_function");
			types.add("logical_literal");
			types.add("logical_representation_item");
			types.add("loop");
			types.add("loss_tangent_measure_with_unit");
			types.add("lot_effectivity");
			types.add("low_order_kinematic_pair");
			types.add("low_order_kinematic_pair_value");
			types.add("low_order_kinematic_pair_with_motion_coupling");
			types.add("low_order_kinematic_pair_with_range");
			types.add("luminous_flux_measure_with_unit");
			types.add("luminous_flux_unit");
			types.add("luminous_intensity_measure_with_unit");
			types.add("luminous_intensity_unit");
			types.add("magnetic_flux_density_measure_with_unit");
			types.add("magnetic_flux_density_unit");
			types.add("magnetic_flux_measure_with_unit");
			types.add("magnetic_flux_unit");
			types.add("make_from_feature_relationship");
			types.add("make_from_usage_option");
			types.add("manifold_solid_brep");
			types.add("manifold_subsurface_shape_representation");
			types.add("manifold_surface_shape_representation");
			types.add("mapped_item");
			types.add("marking");
			types.add("mass_measure_with_unit");
			types.add("mass_unit");
			types.add("mated_part_relationship");
			types.add("material_designation");
			types.add("material_designation_characterization");
			types.add("material_property");
			types.add("material_property_representation");
			types.add("maths_enum_literal");
			types.add("maths_function");
			types.add("maths_space");
			types.add("maths_tuple_literal");
			types.add("maths_variable");
			types.add("maximum_function");
			types.add("measure_qualification");
			types.add("measure_representation_item");
			types.add("measure_with_unit");
			types.add("mechanical_context");
			types.add("mechanical_design_and_draughting_relationship");
			types.add("mechanical_design_geometric_presentation_area");
			types.add("mechanical_design_geometric_presentation_representation");
			types.add("mechanical_design_presentation_representation_with_draughting");
			types.add("mechanical_design_shaded_presentation_area");
			types.add("mechanical_design_shaded_presentation_representation");
			types.add("mechanism_representation");
			types.add("mechanism_state_representation");
			types.add("min_and_major_ply_orientation_basis");
			types.add("minimum_function");
			types.add("minus_expression");
			types.add("minus_function");
			types.add("mod_expression");
			types.add("modified_geometric_tolerance");
			types.add("modified_pattern");
			types.add("modified_solid");
			types.add("modified_solid_with_placed_configuration");
			types.add("modify_element");
			types.add("moments_of_inertia_representation");
			types.add("mult_expression");
			types.add("multi_language_attribute_assignment");
			types.add("multiple_arity_boolean_expression");
			types.add("multiple_arity_function_call");
			types.add("multiple_arity_generic_expression");
			types.add("multiple_arity_numeric_expression");
			types.add("multiply_defined_cartesian_points");
			types.add("multiply_defined_curves");
			types.add("multiply_defined_directions");
			types.add("multiply_defined_edges");
			types.add("multiply_defined_faces");
			types.add("multiply_defined_geometry");
			types.add("multiply_defined_placements");
			types.add("multiply_defined_solids");
			types.add("multiply_defined_surfaces");
			types.add("multiply_defined_vertices");
			types.add("name_assignment");
			types.add("name_attribute");
			types.add("named_unit");
			types.add("narrow_surface_patch");
			types.add("near_point_relationship");
			types.add("nearly_degenerate_geometry");
			types.add("nearly_degenerate_surface_boundary");
			types.add("nearly_degenerate_surface_patch");
			types.add("neutral_sketch_representation");
			types.add("next_assembly_usage_occurrence");
			types.add("ngon_closed_profile");
			types.add("non_manifold_at_edge");
			types.add("non_manifold_at_vertex");
			types.add("non_manifold_surface_shape_representation");
			types.add("non_smooth_geometry_transition_across_edge");
			types.add("non_uniform_zone_definition");
			types.add("not_expression");
			types.add("null_representation_item");
			types.add("numeric_defined_function");
			types.add("numeric_expression");
			types.add("numeric_variable");
			types.add("object_role");
			types.add("odd_function");
			types.add("offset_curve_2d");
			types.add("offset_curve_3d");
			types.add("offset_surface");
			types.add("one_direction_repeat_factor");
			types.add("open_closed_shell");
			types.add("open_edge_loop");
			types.add("open_path_profile");
			types.add("open_shell");
			types.add("or_expression");
			types.add("ordinal_date");
			types.add("ordinate_dimension");
			types.add("organization");
			types.add("organization_assignment");
			types.add("organization_relationship");
			types.add("organization_role");
			types.add("organizational_address");
			types.add("organizational_project");
			types.add("organizational_project_assignment");
			types.add("organizational_project_relationship");
			types.add("organizational_project_role");
			types.add("oriented_closed_shell");
			types.add("oriented_edge");
			types.add("oriented_face");
			types.add("oriented_joint");
			types.add("oriented_open_shell");
			types.add("oriented_path");
			types.add("oriented_surface");
			types.add("outer_boundary_curve");
			types.add("outer_round");
			types.add("outside_profile");
			types.add("over_riding_styled_item");
			types.add("over_used_vertex");
			types.add("overcomplex_geometry");
			types.add("overcomplex_topology_and_geometry_relationship");
			types.add("overlapping_geometry");
			types.add("package_product_concept_feature");
			types.add("pair_representation_relationship");
			types.add("pair_value");
			types.add("parabola");
			types.add("parallel_assembly_constraint");
			types.add("parallel_assembly_constraint_with_dimension");
			types.add("parallel_composed_function");
			types.add("parallel_geometric_constraint");
			types.add("parallel_offset");
			types.add("parallel_offset_geometric_constraint");
			types.add("parallelism_tolerance");
			types.add("parametric_representation_context");
			types.add("part_laminate_table");
			types.add("partial_circular_profile");
			types.add("partial_derivative_expression");
			types.add("partial_derivative_function");
			types.add("partial_document_with_structured_text_representation_assignment");
			types.add("partly_overlapping_curves");
			types.add("partly_overlapping_edges");
			types.add("partly_overlapping_faces");
			types.add("partly_overlapping_solids");
			types.add("partly_overlapping_surfaces");
			types.add("path");
			types.add("path_area_with_parameters");
			types.add("path_feature_component");
			types.add("path_node");
			types.add("path_parameter_representation");
			types.add("path_parameter_representation_context");
			types.add("path_shape_representation");
			types.add("pattern_offset_membership");
			types.add("pattern_omit_membership");
			types.add("pcurve");
			types.add("pdgc_with_dimension");
			types.add("percentage_laminate_table");
			types.add("perpendicular_assembly_constraint");
			types.add("perpendicular_geometric_constraint");
			types.add("perpendicular_to");
			types.add("perpendicularity_tolerance");
			types.add("person");
			types.add("person_and_organization");
			types.add("person_and_organization_address");
			types.add("person_and_organization_assignment");
			types.add("person_and_organization_role");
			types.add("personal_address");
			types.add("pgc_with_dimension");
			types.add("physical_breakdown_context");
			types.add("physical_component");
			types.add("physical_component_feature");
			types.add("physical_component_terminal");
			types.add("physical_element_usage");
			types.add("picture_representation");
			types.add("picture_representation_item");
			types.add("placed_datum_target_feature");
			types.add("placed_feature");
			types.add("placement");
			types.add("planar_box");
			types.add("planar_curve_pair");
			types.add("planar_curve_pair_range");
			types.add("planar_extent");
			types.add("planar_pair");
			types.add("planar_pair_value");
			types.add("planar_pair_with_range");
			types.add("planar_shape_representation");
			types.add("plane");
			types.add("plane_angle_and_length_pair");
			types.add("plane_angle_and_ratio_pair");
			types.add("plane_angle_measure_with_unit");
			types.add("plane_angle_unit");
			types.add("plus_expression");
			types.add("plus_minus_tolerance");
			types.add("ply_laminate_sequence_definition");
			types.add("ply_laminate_table");
			types.add("pocket");
			types.add("pocket_bottom");
			types.add("pogc_with_dimension");
			types.add("point");
			types.add("point_and_vector");
			types.add("point_distance_geometric_constraint");
			types.add("point_on_curve");
			types.add("point_on_edge_curve");
			types.add("point_on_face_surface");
			types.add("point_on_planar_curve_pair");
			types.add("point_on_planar_curve_pair_value");
			types.add("point_on_planar_curve_pair_with_range");
			types.add("point_on_surface");
			types.add("point_on_surface_pair");
			types.add("point_on_surface_pair_value");
			types.add("point_on_surface_pair_with_range");
			types.add("point_path");
			types.add("point_replica");
			types.add("point_style");
			types.add("point_to_point_path");
			types.add("polar_complex_number_literal");
			types.add("polar_complex_number_region");
			types.add("poly_loop");
			types.add("polygonal_area");
			types.add("polyline");
			types.add("position_tolerance");
			types.add("positioned_sketch");
			types.add("power_expression");
			types.add("power_measure_with_unit");
			types.add("power_unit");
			types.add("pre_defined_character_glyph");
			types.add("pre_defined_colour");
			types.add("pre_defined_curve_font");
			types.add("pre_defined_dimension_symbol");
			types.add("pre_defined_geometrical_tolerance_symbol");
			types.add("pre_defined_item");
			types.add("pre_defined_marker");
			types.add("pre_defined_point_marker_symbol");
			types.add("pre_defined_surface_condition_symbol");
			types.add("pre_defined_surface_side_style");
			types.add("pre_defined_symbol");
			types.add("pre_defined_terminator_symbol");
			types.add("pre_defined_text_font");
			types.add("pre_defined_tile");
			types.add("precision_qualifier");
			types.add("predefined_picture_representation_item");
			types.add("prescribed_path");
			types.add("presentation_area");
			types.add("presentation_layer_assignment");
			types.add("presentation_representation");
			types.add("presentation_set");
			types.add("presentation_size");
			types.add("presentation_style_assignment");
			types.add("presentation_style_by_context");
			types.add("presentation_view");
			types.add("presented_item");
			types.add("presented_item_representation");
			types.add("pressure_measure_with_unit");
			types.add("pressure_unit");
			types.add("previous_change_element_assignment");
			types.add("primitive_2d");
			types.add("primitive_2d_with_inner_boundary");
			types.add("prismatic_pair");
			types.add("prismatic_pair_value");
			types.add("prismatic_pair_with_range");
			types.add("procedural_representation");
			types.add("procedural_representation_sequence");
			types.add("procedural_shape_representation");
			types.add("procedural_shape_representation_sequence");
			types.add("process_operation");
			types.add("process_plan");
			types.add("process_product_association");
			types.add("process_property_association");
			types.add("product");
			types.add("product_as_planned");
			types.add("product_category");
			types.add("product_category_relationship");
			types.add("product_class");
			types.add("product_concept");
			types.add("product_concept_context");
			types.add("product_concept_feature");
			types.add("product_concept_feature_association");
			types.add("product_concept_feature_category");
			types.add("product_concept_feature_category_usage");
			types.add("product_concept_relationship");
			types.add("product_context");
			types.add("product_data_and_data_quality_relationship");
			types.add("product_definition");
			types.add("product_definition_context");
			types.add("product_definition_context_association");
			types.add("product_definition_context_role");
			types.add("product_definition_effectivity");
			types.add("product_definition_element_relationship");
			types.add("product_definition_formation");
			types.add("product_definition_formation_relationship");
			types.add("product_definition_formation_with_specified_source");
			types.add("product_definition_group_assignment");
			types.add("product_definition_kinematics");
			types.add("product_definition_occurrence_relationship");
			types.add("product_definition_process");
			types.add("product_definition_relationship");
			types.add("product_definition_relationship_kinematics");
			types.add("product_definition_resource");
			types.add("product_definition_shape");
			types.add("product_definition_substitute");
			types.add("product_definition_usage");
			types.add("product_definition_with_associated_documents");
			types.add("product_design_to_individual");
			types.add("product_design_version_to_individual");
			types.add("product_identification");
			types.add("product_material_composition_relationship");
			types.add("product_planned_to_realized");
			types.add("product_process_plan");
			types.add("product_related_product_category");
			types.add("product_relationship");
			types.add("product_specification");
			types.add("profile_floor");
			types.add("projected_zone_definition");
			types.add("projected_zone_definition_with_offset");
			types.add("projection_curve");
			types.add("projection_directed_callout");
			types.add("promissory_usage_occurrence");
			types.add("property_definition");
			types.add("property_definition_relationship");
			types.add("property_definition_representation");
			types.add("property_process");
			types.add("protrusion");
			types.add("qualified_representation_item");
			types.add("qualitative_uncertainty");
			types.add("quantified_assembly_component_usage");
			types.add("quantifier_expression");
			types.add("quasi_uniform_curve");
			types.add("quasi_uniform_surface");
			types.add("rack_and_pinion_pair");
			types.add("rack_and_pinion_pair_value");
			types.add("rack_and_pinion_pair_with_range");
			types.add("radioactivity_measure_with_unit");
			types.add("radioactivity_unit");
			types.add("radius_dimension");
			types.add("radius_geometric_constraint");
			types.add("range_characteristic");
			types.add("ratio_measure_with_unit");
			types.add("ratio_unit");
			types.add("rational_b_spline_curve");
			types.add("rational_b_spline_surface");
			types.add("rational_representation_item");
			types.add("rationalize_function");
			types.add("real_defined_function");
			types.add("real_interval_from_min");
			types.add("real_interval_to_max");
			types.add("real_literal");
			types.add("real_numeric_variable");
			types.add("real_representation_item");
			types.add("real_tuple_literal");
			types.add("rectangular_area");
			types.add("rectangular_array_placement_group_component");
			types.add("rectangular_closed_profile");
			types.add("rectangular_composite_surface");
			types.add("rectangular_composite_surface_transition_locator");
			types.add("rectangular_pattern");
			types.add("rectangular_trimmed_surface");
			types.add("referenced_modified_datum");
			types.add("reindexed_array_function");
			types.add("relative_event_occurrence");
			types.add("removal_volume");
			types.add("rep_item_group");
			types.add("repackaging_function");
			types.add("reparametrised_composite_curve_segment");
			types.add("replicate_feature");
			types.add("repositioned_neutral_sketch");
			types.add("representation");
			types.add("representation_context");
			types.add("representation_item");
			types.add("representation_item_relationship");
			types.add("representation_map");
			types.add("representation_relationship");
			types.add("representation_relationship_with_transformation");
			types.add("representative_shape_representation");
			types.add("requirement_assigned_object");
			types.add("requirement_assignment");
			types.add("requirement_for_action_resource");
			types.add("requirement_source");
			types.add("resistance_measure_with_unit");
			types.add("resistance_unit");
			types.add("resource_property");
			types.add("resource_property_representation");
			types.add("resource_requirement_type");
			types.add("restriction_function");
			types.add("resulting_path");
			types.add("retention");
			types.add("revolute_pair");
			types.add("revolute_pair_value");
			types.add("revolute_pair_with_range");
			types.add("revolved_area_solid");
			types.add("revolved_face_solid");
			types.add("revolved_face_solid_with_trim_conditions");
			types.add("revolved_profile");
			types.add("rgc_with_dimension");
			types.add("rib_top");
			types.add("rib_top_floor");
			types.add("right_angular_wedge");
			types.add("right_circular_cone");
			types.add("right_circular_cylinder");
			types.add("right_to_usage_association");
			types.add("rigid_link_representation");
			types.add("rigid_subsketch");
			types.add("role_association");
			types.add("rolling_curve_pair");
			types.add("rolling_curve_pair_value");
			types.add("rolling_surface_pair");
			types.add("rolling_surface_pair_value");
			types.add("rotation_about_direction");
			types.add("round_hole");
			types.add("rounded_end");
			types.add("rounded_u_profile");
			types.add("roundness_tolerance");
			types.add("row_representation_item");
			types.add("row_value");
			types.add("row_variable");
			types.add("rule_action");
			types.add("rule_condition");
			types.add("rule_definition");
			types.add("rule_set");
			types.add("rule_set_group");
			types.add("rule_software_definition");
			types.add("rule_superseded_assignment");
			types.add("rule_supersedence");
			types.add("ruled_surface_swept_area_solid");
			types.add("runout_zone_definition");
			types.add("runout_zone_orientation");
			types.add("runout_zone_orientation_reference_direction");
			types.add("satisfied_requirement");
			types.add("satisfies_requirement");
			types.add("satisfying_item");
			types.add("scalar_variable");
			types.add("scattering_parameter");
			types.add("screw_pair");
			types.add("screw_pair_value");
			types.add("screw_pair_with_range");
			types.add("sculptured_solid");
			types.add("sdgc_with_dimension");
			types.add("seam_curve");
			types.add("security_classification");
			types.add("security_classification_assignment");
			types.add("security_classification_level");
			types.add("selector_function");
			types.add("self_intersecting_curve");
			types.add("self_intersecting_geometry");
			types.add("self_intersecting_loop");
			types.add("self_intersecting_shell");
			types.add("self_intersecting_surface");
			types.add("serial_numbered_effectivity");
			types.add("series_composed_function");
			types.add("shape_aspect");
			types.add("shape_aspect_associativity");
			types.add("shape_aspect_deriving_relationship");
			types.add("shape_aspect_relationship");
			types.add("shape_aspect_relationship_representation_association");
			types.add("shape_criteria_representation_with_accuracy");
			types.add("shape_data_quality_assessment_by_logical_test");
			types.add("shape_data_quality_assessment_by_numerical_test");
			types.add("shape_data_quality_criteria_representation");
			types.add("shape_data_quality_criterion");
			types.add("shape_data_quality_criterion_and_accuracy_association");
			types.add("shape_data_quality_inspected_shape_and_result_relationship");
			types.add("shape_data_quality_inspection_criterion_report");
			types.add("shape_data_quality_inspection_instance_report");
			types.add("shape_data_quality_inspection_instance_report_item");
			types.add("shape_data_quality_inspection_result");
			types.add("shape_data_quality_inspection_result_representation");
			types.add("shape_data_quality_lower_value_limit");
			types.add("shape_data_quality_upper_value_limit");
			types.add("shape_data_quality_value_limit");
			types.add("shape_data_quality_value_range");
			types.add("shape_defining_relationship");
			types.add("shape_definition_representation");
			types.add("shape_dimension_representation");
			types.add("shape_feature_definition");
			types.add("shape_inspection_result_accuracy_association");
			types.add("shape_inspection_result_representation_with_accuracy");
			types.add("shape_measurement_accuracy");
			types.add("shape_representation");
			types.add("shape_representation_relationship");
			types.add("shape_representation_with_parameters");
			types.add("shape_summary_request_with_representative_value");
			types.add("shell_based_surface_model");
			types.add("shell_based_wireframe_model");
			types.add("shell_based_wireframe_shape_representation");
			types.add("shelled_solid");
			types.add("short_length_curve");
			types.add("short_length_curve_segment");
			types.add("short_length_edge");
			types.add("si_absorbed_dose_unit");
			types.add("si_capacitance_unit");
			types.add("si_conductance_unit");
			types.add("si_dose_equivalent_unit");
			types.add("si_electric_charge_unit");
			types.add("si_electric_potential_unit");
			types.add("si_energy_unit");
			types.add("si_force_unit");
			types.add("si_frequency_unit");
			types.add("si_illuminance_unit");
			types.add("si_inductance_unit");
			types.add("si_magnetic_flux_density_unit");
			types.add("si_magnetic_flux_unit");
			types.add("si_power_unit");
			types.add("si_pressure_unit");
			types.add("si_radioactivity_unit");
			types.add("si_resistance_unit");
			types.add("si_unit");
			types.add("simple_boolean_expression");
			types.add("simple_clause");
			types.add("simple_generic_expression");
			types.add("simple_numeric_expression");
			types.add("simple_string_expression");
			types.add("simultaneous_constraint_group");
			types.add("sin_function");
			types.add("single_area_csg_2d_shape_representation");
			types.add("single_boundary_csg_2d_shape_representation");
			types.add("skew_line_distance_geometric_constraint");
			types.add("slash_expression");
			types.add("sliding_curve_pair");
			types.add("sliding_curve_pair_value");
			types.add("sliding_surface_pair");
			types.add("sliding_surface_pair_value");
			types.add("slot");
			types.add("slot_end");
			types.add("small_area_face");
			types.add("small_area_surface");
			types.add("small_area_surface_patch");
			types.add("small_volume_solid");
			types.add("smeared_material_definition");
			types.add("software_for_data_quality_check");
			types.add("solid_angle_measure_with_unit");
			types.add("solid_angle_unit");
			types.add("solid_curve_font");
			types.add("solid_model");
			types.add("solid_replica");
			types.add("solid_with_angle_based_chamfer");
			types.add("solid_with_chamfered_edges");
			types.add("solid_with_circular_pattern");
			types.add("solid_with_circular_pocket");
			types.add("solid_with_circular_protrusion");
			types.add("solid_with_conical_bottom_round_hole");
			types.add("solid_with_constant_radius_edge_blend");
			types.add("solid_with_curved_slot");
			types.add("solid_with_depression");
			types.add("solid_with_double_offset_chamfer");
			types.add("solid_with_excessive_number_of_voids");
			types.add("solid_with_flat_bottom_round_hole");
			types.add("solid_with_general_pocket");
			types.add("solid_with_general_protrusion");
			types.add("solid_with_groove");
			types.add("solid_with_hole");
			types.add("solid_with_incomplete_circular_pattern");
			types.add("solid_with_incomplete_rectangular_pattern");
			types.add("solid_with_pocket");
			types.add("solid_with_protrusion");
			types.add("solid_with_rectangular_pattern");
			types.add("solid_with_rectangular_pocket");
			types.add("solid_with_rectangular_protrusion");
			types.add("solid_with_shape_element_pattern");
			types.add("solid_with_single_offset_chamfer");
			types.add("solid_with_slot");
			types.add("solid_with_spherical_bottom_round_hole");
			types.add("solid_with_stepped_round_hole");
			types.add("solid_with_stepped_round_hole_and_conical_transitions");
			types.add("solid_with_straight_slot");
			types.add("solid_with_tee_section_slot");
			types.add("solid_with_through_depression");
			types.add("solid_with_trapezoidal_section_slot");
			types.add("solid_with_variable_radius_edge_blend");
			types.add("solid_with_wrong_number_of_voids");
			types.add("source_for_requirement");
			types.add("sourced_requirement");
			types.add("specification_definition");
			types.add("specified_higher_usage_occurrence");
			types.add("sphere");
			types.add("spherical_cap");
			types.add("spherical_pair");
			types.add("spherical_pair_value");
			types.add("spherical_pair_with_pin");
			types.add("spherical_pair_with_pin_and_range");
			types.add("spherical_pair_with_range");
			types.add("spherical_surface");
			types.add("sql_mappable_defined_function");
			types.add("square_root_function");
			types.add("square_u_profile");
			types.add("standard_uncertainty");
			types.add("start_request");
			types.add("start_work");
			types.add("steep_angle_between_adjacent_edges");
			types.add("steep_angle_between_adjacent_faces");
			types.add("steep_geometry_transition_across_edge");
			types.add("step");
			types.add("straightness_tolerance");
			types.add("string_defined_function");
			types.add("string_expression");
			types.add("string_literal");
			types.add("string_variable");
			types.add("structured_dimension_callout");
			types.add("structured_text_composition");
			types.add("structured_text_representation");
			types.add("styled_item");
			types.add("su_parameters");
			types.add("subedge");
			types.add("subface");
			types.add("subsketch");
			types.add("substring_expression");
			types.add("summary_report_request");
			types.add("supplied_part_relationship");
			types.add("surface");
			types.add("surface_condition_callout");
			types.add("surface_curve");
			types.add("surface_curve_swept_area_solid");
			types.add("surface_distance_assembly_constraint_with_dimension");
			types.add("surface_distance_geometric_constraint");
			types.add("surface_of_linear_extrusion");
			types.add("surface_of_revolution");
			types.add("surface_pair");
			types.add("surface_pair_with_range");
			types.add("surface_patch");
			types.add("surface_patch_set");
			types.add("surface_profile_tolerance");
			types.add("surface_rendering_properties");
			types.add("surface_replica");
			types.add("surface_side_style");
			types.add("surface_smoothness_geometric_constraint");
			types.add("surface_style_boundary");
			types.add("surface_style_control_grid");
			types.add("surface_style_fill_area");
			types.add("surface_style_parameter_line");
			types.add("surface_style_reflectance_ambient");
			types.add("surface_style_reflectance_ambient_diffuse");
			types.add("surface_style_reflectance_ambient_diffuse_specular");
			types.add("surface_style_rendering");
			types.add("surface_style_rendering_with_properties");
			types.add("surface_style_segmentation_curve");
			types.add("surface_style_silhouette");
			types.add("surface_style_transparent");
			types.add("surface_style_usage");
			types.add("surface_texture_representation");
			types.add("surface_with_excessive_patches_in_one_direction");
			types.add("surface_with_small_curvature_radius");
			types.add("surfaced_open_shell");
			types.add("swept_area_solid");
			types.add("swept_curve_surface_geometric_constraint");
			types.add("swept_disk_solid");
			types.add("swept_face_solid");
			types.add("swept_point_curve_geometric_constraint");
			types.add("swept_surface");
			types.add("symbol");
			types.add("symbol_colour");
			types.add("symbol_representation");
			types.add("symbol_representation_map");
			types.add("symbol_style");
			types.add("symbol_target");
			types.add("symmetric_shape_aspect");
			types.add("symmetry_geometric_constraint");
			types.add("symmetry_tolerance");
			types.add("table_representation_item");
			types.add("tactile_appearance_representation");
			types.add("tagged_text_format");
			types.add("tagged_text_item");
			types.add("tan_function");
			types.add("tangent");
			types.add("tangent_assembly_constraint");
			types.add("tangent_geometric_constraint");
			types.add("taper");
			types.add("tee_profile");
			types.add("terminator_symbol");
			types.add("text_font");
			types.add("text_font_family");
			types.add("text_font_in_family");
			types.add("text_literal");
			types.add("text_literal_with_associated_curves");
			types.add("text_literal_with_blanking_box");
			types.add("text_literal_with_delineation");
			types.add("text_literal_with_extent");
			types.add("text_reference");
			types.add("text_string_representation");
			types.add("text_style");
			types.add("text_style_for_defined_font");
			types.add("text_style_with_box_characteristics");
			types.add("text_style_with_mirror");
			types.add("text_style_with_spacing");
			types.add("thermal_component");
			types.add("thermal_resistance_measure_with_unit");
			types.add("thermal_resistance_unit");
			types.add("thermodynamic_temperature_measure_with_unit");
			types.add("thermodynamic_temperature_unit");
			types.add("thickened_face_solid");
			types.add("thickness_laminate_table");
			types.add("thread");
			types.add("thread_runout");
			types.add("time_interval");
			types.add("time_interval_assignment");
			types.add("time_interval_based_effectivity");
			types.add("time_interval_relationship");
			types.add("time_interval_role");
			types.add("time_interval_with_bounds");
			types.add("time_measure_with_unit");
			types.add("time_unit");
			types.add("tolerance_value");
			types.add("tolerance_zone");
			types.add("tolerance_zone_definition");
			types.add("tolerance_zone_form");
			types.add("topological_representation_item");
			types.add("topology_related_to_multiply_defined_geometry");
			types.add("topology_related_to_nearly_degenerate_geometry");
			types.add("topology_related_to_overlapping_geometry");
			types.add("topology_related_to_self_intersecting_geometry");
			types.add("toroidal_surface");
			types.add("torus");
			types.add("total_runout_tolerance");
			types.add("track_blended_solid");
			types.add("track_blended_solid_with_end_conditions");
			types.add("transformation_with_derived_angle");
			types.add("transition_feature");
			types.add("trimmed_curve");
			types.add("turned_knurl");
			types.add("two_direction_repeat_factor");
			types.add("type_qualifier");
			types.add("unary_boolean_expression");
			types.add("unary_function_call");
			types.add("unary_generic_expression");
			types.add("unary_numeric_expression");
			types.add("unbound_parameter_environment");
			types.add("unbound_variational_parameter");
			types.add("unbound_variational_parameter_semantics");
			types.add("uncertainty_assigned_representation");
			types.add("uncertainty_measure_with_unit");
			types.add("uncertainty_qualifier");
			types.add("unconstrained_pair");
			types.add("unconstrained_pair_value");
			types.add("unequally_disposed_geometric_tolerance");
			types.add("uniform_curve");
			types.add("uniform_product_space");
			types.add("uniform_resource_identifier");
			types.add("uniform_surface");
			types.add("universal_pair");
			types.add("universal_pair_value");
			types.add("universal_pair_with_range");
			types.add("unused_patches");
			types.add("usage_association");
			types.add("user_defined_curve_font");
			types.add("user_defined_marker");
			types.add("user_defined_terminator_symbol");
			types.add("user_selected_elements");
			types.add("user_selected_shape_elements");
			types.add("value_function");
			types.add("value_range");
			types.add("value_representation_item");
			types.add("variable");
			types.add("variable_semantics");
			types.add("variational_current_representation_relationship");
			types.add("variational_parameter");
			types.add("variational_representation");
			types.add("variational_representation_item");
			types.add("vector");
			types.add("vector_style");
			types.add("vee_profile");
			types.add("velocity_measure_with_unit");
			types.add("velocity_unit");
			types.add("versioned_action_request");
			types.add("versioned_action_request_relationship");
			types.add("vertex");
			types.add("vertex_loop");
			types.add("vertex_point");
			types.add("vertex_shell");
			types.add("view_volume");
			types.add("visual_appearance_representation");
			types.add("volume");
			types.add("volume_measure_with_unit");
			types.add("volume_unit");
			types.add("week_of_year_and_day_date");
			types.add("wire_shell");
			types.add("wrongly_oriented_void");
			types.add("wrongly_placed_loop");
			types.add("wrongly_placed_void");
			types.add("xor_expression");
			types.add("year_month");
			types.add("zero_surface_normal");
			types.add("zone_structural_makeup");		}
}
